	list		p=16f1454
	#include	<p16f1454.inc>

	__config _CONFIG1, _FOSC_INTOSC & _WDTE_SWDTEN & _PWRTE_ON & _MCLRE_OFF & _CP_OFF & _BOREN_ON & _CLKOUTEN_OFF  & _IESO_OFF & _FCMEN_OFF
	__config _CONFIG2, _WRT_OFF & _CPUDIV_NOCLKDIV & _USBLSCLK_48MHz & _PLLMULT_3x & _PLLEN_ENABLED & _STVREN_ON & _BORV_LO & _LPBOR_OFF & _LVP_OFF

		;DEFINICIA PORTOV
	#define		IRQ				PORTA,4
	#define		CE				PORTA,5
	#define		CSN				PORTC,2
	#define		MISO			PORTC,3
	#define		MOSI			PORTC,4
	#define		SCK				PORTC,5

		;DEFINICIA BITOV USB KOMUNIKACIE
	#define		Ziadost_spracovana		VYPINACE,0
	#define		DEVICE_DESC				DESC,0
	#define		CONFIGURATION_DESC		DESC,1
	#define		REPORT_DESC				DESC,2
	#define		STRING_LANG_DESC		DESC,3
	#define		STRING_MANUFACT_DESC	DESC,4
	#define		STRING_VENDOR_DESC		DESC,5

		;ADRESY RAM ENDPOINTU 0													BANK 1
	#define		ADR_H_EP0_OUT_setup		0x20
	#define		ADR_L_EP0_OUT_setup		0x50		;SetupPacket
	#define		ADR_H_EP0_IN_control	0x20
	#define		ADR_L_EP0_IN_control	0x58		;ControlTransferBuffer 

		;ADRESY RAM ENDPOINTOV 1_OUT A 1_IN										
	#define		ADR_H_EP1_OUT			0x01
	#define		ADR_L_EP1_OUT			0x20									;BANK 2
	#define		ADR_H_EP1_IN			0x01
	#define		ADR_L_EP1_IN			0xA0									;BANK 3
	
		;DLZKY RAM ENDPOINTU 0
	#define		B_CNT_EP0_IN			0x08
	#define		B_CNT_EP0_OUT			0x08

		;DLZKY RAM ENDPOINTU 1
	#define		B_CNT_EP1_IN			0x40		;64 bajtov
	#define		B_CNT_EP1_OUT			0x40		;64 bajtov

		;ADRESY PRE Rx/Tx DAT MODULU RFM75 										
	#define		ADR_H_Rx					0x22	;od 0x2200 (BANK 7).....
	#define		ADR_L_Rx					0x00	;....az do 0x22FF (cast BANKy 10) = 255 byte
	#define		ADR_H_Tx					0x22	;od 0x2200 (BANK 7).....
	#define		ADR_L_Tx					0x22	;....az do 0x22FF (cast BANKy 10) = 255 byte
	#define		ADR_H						0x22	;od 0x2200 (BANK 7).....
	#define		ADR_L						0x44	;....az do 0x22FF (cast BANKy 10) = 255 byte

		;Device states (Chap 9.1.1)
	#define 	ADDRESS					0x01
	#define 	ENUMERACIA				0x02
	#define 	NAKONFIGUROVANE			0x03

		;Control Transfer Stages - see USB spec chapter 5
	#define 	SETUP_STADIUM			0x00	;Start of a control transfer (followed by 0 or more data stages)
	#define 	DATA_OUT_STADIUM		0x01	;Data from host to device
	#define 	DATA_IN_STADIUM			0x02	;Data from device to host

		; PID hodnoty
	#define 	OUT_Token				b'00000001'
	#define 	IN_Token				b'00001001'
	#define 	SOF_Token				b'00000101'
	#define 	SETUP_Token				b'00001101'
	#define		DATA0					b'00000011'
	#define		DATA1					b'00001011'
	#define		ACK_Handshake			b'00000010'
	#define		NAK_Handshake			b'00001010'
	#define		STALL_Handshake			b'00001110'
	
		; Commands
	#define 	SET_ADDRESS				0x05
	#define 	GET_DESCRIPTOR			0x06
	#define 	GET_CONFIGURATION		0x08
	#define 	SET_CONFIGURATION		0x09
	#define		GET_INTERFACE			0x0A
	#define		SET_INTERFACE			0x0B
	
		; Descriptor Types
	#define 	DEVICE_DESCRIPTOR			0x01
	#define 	CONFIGURATION_DESCRIPTOR	0x02
	#define 	STRING_DESCRIPTOR			0x03
	#define 	INTERFACE_DESCRIPTOR		0x04
	#define 	ENDPOINT_DESCRIPTOR			0x05
	
		; Class Descriptor Types
	#define 	HID_DESCRIPTOR			0x21
	#define 	REPORT_DESCRIPTOR		0x22
	#define 	PHYSICAL_DESCRIPTOR		0x23
	
		; HID Class specific requests
	#define 	GET_REPORT				0x01
	#define 	GET_IDLE				0x02
	#define 	GET_PROTOCOL			0x03
	#define 	SET_REPORT				0x09
	#define 	SET_IDLE				0x0A
	#define 	SET_PROTOCOL			0x0B

		;DEFINICIA PID a VID
	#define		VIDH					0x04
	#define		VIDL					0xD8
	#define		PIDH					0x01
	#define		PIDL					0xA5
	#define		VERH					0x00
	#define		VERL					0x01

		;Hodnoty atributov v bmRequestType (Transfer, Type, Recipient)
	#define		Device_to_Host		.1
	#define		Host_to_Device		.0
	#define		Standard			.0
	#define		Class				.1
	#define		Vendor				.2
	#define		Reserved			.3
	#define		Device				.0
	#define		Interface			.1
	#define		Endpoint			.2
	#define		Other				.3

		;Hodnoty atributov v USTAT
	#define		Posledny_bol_token_OUT_al_SETUP	.0
	#define		Posledny_bol_token_IN			.1
	#define		IN								.1
	#define		OUT								.0
	#define		Endpoint_1						.1
	#define		Endpoint_0						.0

					;Dual port RAM:
					;BANK 0		0020 - 006F			2000 - 204F 	80 Byte
					;BANK 1		00A0 - 00EF 		2050 - 209F		80 Byte
					;BANK 2		0120 - 016F 		20A0 - 20EF		80 Byte
					;BANK 3		01A0 - 01EF 		20F0 - 213F 	80 Byte		Pouzite pre USB EP1 IN
					;BANK 4		0220 - 026F 		2140 - 218F 	80 Byte		RAM a premenne pre Endpoint 0
					;BANK 5		02A0 - 02EF 		2190 - 21DF 	80 Byte		Pouzite pre USB EP1 OUT
					;BANK 6		0320 - 032F 		21E0 - 21EF 	16 Byte

		;DEFINICIA PRIZNAKOVYCH BITOV
	#define		Prisli_data_USB					FLAGS,0
	#define		Povolenie_USB					FLAGS,1









		;Paket RFM75:
;	|| Preambula (1Byte) || Adresa (3-5Byte) || Kontrola paketov (9/0bite) || Data (0-32Byte) || CRC (2/1Byte) || 

;	Kontrola paketov (9/0bite) obsahuje:  || Dlzka Dat (6bit) || Pocitadlo (2bit) || NO_ACK (1bit) ||


		;Adresy modulu RFM75
	#define		CONFIG						0x00
	#define		EN_AA						0x01
	#define		EN_RXADDR					0x02
	#define		SETUP_AW					0x03
	#define		SETUP_RETR					0x04
	#define		RF_CH						0x05
	#define		RF_SETUP					0x06
	#define		STATUS_RFM75				0x07
	#define		OBSERVE_TX					0x08
	#define		CD							0x09
	#define		RX_ADDR_P0					0x0A	;5 byte
	#define		RX_ADDR_P1					0x0B	;5 byte
	#define		RX_ADDR_P2					0x0C
	#define		RX_ADDR_P3					0x0D
	#define		RX_ADDR_P4					0x0E
	#define		RX_ADDR_P5					0x0F
	#define		TX_ADDR						0x10	;5 byte
	#define		RX_PW_P0					0x11
	#define		RX_PW_P1					0x12
	#define		RX_PW_P2					0x13
	#define		RX_PW_P3					0x14
	#define		RX_PW_P4					0x15
	#define		RX_PW_P5					0x16
	#define		FIFO_STATUS					0x17
	#define		DYNPD						0x1C
	#define		FEATURE						0x1D


		;Obsluzne kody pre RFM75
	#define		ZMENA_FREKVENCIE			0xBB
	#define		DATA_Z_PC					0xAA
	#define		DATA_DO_PC					0x17
	#define		Init_RFM75					0x11
	#define		NastavenieAdresyRFM75		0xAD

;Zoznam uzitocnych bitov:

;	Register	bit			popis
;---------------------------------------------
;	CONFIG		CRCO		Nastavenie CRC na 2/1Byte
;	CONFIG		PWR_UP		1: POWER UP, 0:POWER DOWN
;	CONFIG		PRIM_RX		1: PRX, 0: PTX
;	EN_AA		EN_AA		Enable auto ACK (5 bitov) (P0-P5)
;	SETUP_RETR	ARD			Casova medzera medzi opakovaniami paketov
;	SETUP_RETR	ARC			Pocet opakovani paketov
;	EN_RXADDR	EN_RXADDR	Zapnutie kontroly adresy v prijatom pakete (5 bitov) (P0-P5)
;	SETUP_AW	SETUP_AW	Pocet Byte adresy
;	RF_CH		RF_CH		Volba VF kanala.
;	RF_SETUP	RF_DR		Volba rychlosti prenosu	
;	RF_SETUP	RF_PWR		Volba VF vykonu modulu	
;	RF_SETUP	LNA_HCURR	Volba citlivosti prijimaca.
;	OBSERVE_TX	PLOS_CNT	Pocitanie stratenych paketov (max.15, nuluje sa zapisom na RF_CH)
;	OBSERVE_TX	ARC_CNT		Pocitanie pokusov pri znovuodosielani paketu.
;	CD			CD			Detekcia nosnej
;	RX_ADDR		RX_ADDR		Zadanie RX adries pre ucastnikov P0-P5 (5 Byte)
;	TX_ADDR		TX_ADDR		Zadanie TX adresy.
;	RX_PW		RX_PW		Zadanie poctu Byte uzitocnych dat v pakete pre ucastnikov P0-P5 (5 Byte)
;	DYNPD		DYNPD		Zapnutie dynamickej dlzky uzitocnych dat v pakete pre ucastnikov P0-P5 (5 bite)
;	FEATURE		EN_DPL		Zapnutie dynamickej dlzky uzitocnych dat v pakete
;	FEATURE		EN_ACK_PAY	Zapnutie odosielania paketov s bitom ACK na konci paketu
;	FEATURE		EN_DYN_ACK	Povolenie pouzivania prikazu W_TX_PAYLOAD_NOACK pre odoslanie paketu bez ACK na konci.





		;RIADIACE REGISTRE USB JEDNOTKY SIE ENDPOINTOV 0 a 1
    CBLOCK 0x0020 
		BD0STAT_OUT		;32		0x20			1
		BD0CNT_OUT
		BD0ADRL_OUT
		BD0ADRH_OUT
		BD0STAT_IN
		BD0CNT_IN
		BD0ADRL_IN
		BD0ADRH_IN	
		BD1STAT_OUT		;40		0x28
		BD1CNT_OUT
		BD1ADRL_OUT
		BD1ADRH_OUT
		BD1STAT_IN
		BD1CNT_IN
		BD1ADRL_IN
		BD1ADRH_IN		;47		0x2F			16
		;--------DEFINICIA PREMENNYCH------------------------
		N1				;48		0x30			17
		N10
		N100
		TMP_P1
		TMP_P2
		TMP_P3
		TMP_P4
		Adresa_USB_RAM			
		Hodnota_do_USB_RAM
		Hodnota_z_USB_RAM
		FLAGS
		count1
		SPI_read_register
		SPI_write_register
		SPI_Status_register
		SPI_bitcnt
		SPI_Adresa
		SPI_datacnt
		SPI_bytcnt
		SPI_addrcnt
		Pocet_byte_RFM75
		TMP_1_SPI
		TMP_MASKA_SPI
		TMP_1_USB
		TMP			
		cnt_RFM75

		CONFIG_RAM_PIC	
		EN_AA_RAM_PIC
		SETUP_RETR_RAM_PIC
		EN_RXADDR_RAM_PIC
		RF_SETUP_RAM_PIC
		FEATURE_TX_PIC
		
					;						39
			;------------------------------------------		
		;max. 			111		0x6F			80
	ENDC

















		;RAM A PREMENNE USB KOMUNIKACIE ENDPOINTU 0
	CBLOCK	0x00A0														; BANK 1
			;OUT token
		bmRequestType					; 0x00A0
		bRequest	
		wValue0	
		wValue1	
		wIndex0	
		wIndex1	
		wLength_LSB	
		wLength_MSB	
			;IN token
		USB_RAM0_BYTE_1_IN				; 0x00A8
		USB_RAM0_BYTE_2_IN		
		USB_RAM0_BYTE_3_IN		
		USB_RAM0_BYTE_4_IN		
		USB_RAM0_BYTE_5_IN		
		USB_RAM0_BYTE_6_IN		
		USB_RAM0_BYTE_7_IN		
		USB_RAM0_BYTE_8_IN				; 0x00AF
		;-----------Premenne pre komunikaciu EP0----------
		Pocet_Byte_EP0_IN						; 0x00B0
		ADRESA			
		POZICIA
		Pocet_byte_z_deskriptora
		Stadium_procesu
		AktualnaKonfiguracia
		Stav_zariadenia
		Poziadavka
		descriptorType
		descriptorIndex
		VYPINACE
		DESC
		Smer_poziadavky
		Typ_poziadavky
		Prijemca_poziadavky				
		Hodnota0_poziadavky				; 0x00C0
		Hodnota1_poziadavky
		Index0_poziadavky
		Pozadovany_pocet_byte
		Naposledy_aktivny_endpoint
		Posledny_smer_prenosu
		PID_paketu
		count
	ENDC

;***************************************************************************************************************************
	org		00h
	GOTO	START	
;***************************************************************************************************************************
	org		004h
	goto 	prerusenie
;*************************************************************************************************************************



Adresa_RFM75	addwf 	PCL,f

		dt	0x00		;1 CONFIG
		dt	0x01		;2 EN_AA
		dt	0x02		;3 EN_RXADDR
		dt	0x03		;4 SETUP_AW
		dt	0x04		;5 SETUP_RETR
		dt	0x05		;6 RF_CH
		dt	0x06		;7 RF_SETUP
		dt	0x07		;8 STATUS
		dt	0x0A		;9 RX_ADDR_P0_1
		dt	0x0B		;10 RX_ADDR_P1_1
		dt	0x0C		;11 RX_ADDR_P2
		dt	0x0D		;12 RX_ADDR_P3
		dt	0x0E		;13 RX_ADDR_P4
		dt	0x0F		;14 RX_ADDR_P5
		dt	0x10		;15 TX_ADDR_1
		dt	0x11		;16 RX_PW_P0
		dt	0x12		;17 RX_PW_P1
		dt	0x13		;18 RX_PW_P2
		dt	0x14		;19 RX_PW_P3
		dt	0x15		;20 RX_PW_P4
		dt	0x16		;21 RX_PW_P5
		dt	0x1C		;22 DYNPD
		dt	0x1D		;23 FEATURE
		dt	0x00




;oooo

Default_data_RFM75	addwf 	PCL,f

		dt	b'00111111'		;1 CONFIG 	6:MASK_RX_DR(z), 5:MASK_TX_DS(v), 4:MASK_MAX_RT(v), 3:EN_CRC(z), 2:CRCO(2B), 1:PWR_UP(z), 0:PRIM_RX(prx)						
		dt	b'00000001'		;2 EN_AA	 	5:AutoACK-P5(v), 4:AutoACK-P4(v), 3:AutoACK-P3(v), 2:AutoACK-P2(v), 1:AutoACK-P1(v), 0:AutoACK-P0(v). 
		dt	b'00000001'		;3 EN_RXADDR		5:RxAdress-P5(v), 4:RxAdress-P4(v), 3:RxAdress-P3(v), 2:RxAdress-P2(v), 1:RxAdress-P1(v), 0:RxAdress-P0(z).
		dt	b'00000001'		;4 SETUP_AW		Dlzka adresy. 1-0:00=bez, 01=3byte, 10=4byte, 11=5byte
		dt	0x0F			;5 SETUP_RETR		7-4:Retransmission Delay=250*(X+1)us, 3-0:Retransmission Count=Xkrat (X = 0 to 15)
		dt	.127				;6 RF_CH			6-0:Frekvencia = 2400 + X MHz. (X = 0 to 127) Max.2483.5MHz(?)
		dt	b'00001111'		;7 RF_SETUP		5+3:Rychlost 00=1Mbps, 01=2Mbps, 10=250Kbps, 11=2Mbps. 4:PLL_LOCK. 2-1:VykonTX. 0:CitlivostRX
		dt	b'01110000'		;8 STATUS			6:ClearRX_DR, 5:ClearTX_DS, 4:ClearMAX_RT. (Ostatne bity len na citanie.)
		dt	0xE1			;9 RX_ADDR_P0_1		RX adresa pre ucastnika 1 - Prvy (LSB) bajt
		dt	0xE2			;10 RX_ADDR_P0_2		RX adresa pre ucastnika 1 - Druhy bajt
		dt	0xE3			;11 RX_ADDR_P0_3		RX adresa pre ucastnika 1 - Treti bajt
		dt	0xE4			;12 RX_ADDR_P0_4		RX adresa pre ucastnika 1 - Stvrty bajt
		dt	0xE5			;13 RX_ADDR_P0_5		RX adresa pre ucastnika 1 - Piaty (MSB)bajt
		dt	0xC2			;14 RX_ADDR_P1_1		RX adresa pre ucastnika 2 - Prvy (LSB) bajt
		dt	0xC2			;15 RX_ADDR_P1_2		RX adresa pre ucastnika 2 - Druhy bajt
		dt	0xC2			;16 RX_ADDR_P1_3		RX adresa pre ucastnika 2 - Treti bajt
		dt	0xC2			;17 RX_ADDR_P1_4		RX adresa pre ucastnika 2 - Stvrty bajt
		dt	0xC2			;18 RX_ADDR_P1_5		RX adresa pre ucastnika 2 - Piaty (MSB) bajt
		dt	0xC3			;19 RX_ADDR_P2			RX adresa pre ucastnika 3 - Iba LSB bajt. MSB sa rovnaju RX_ADDR_P1.
		dt	0xC4			;20 RX_ADDR_P3			RX adresa pre ucastnika 4 - Iba LSB bajt. MSB sa rovnaju RX_ADDR_P1.
		dt	0xC5			;21 RX_ADDR_P4			RX adresa pre ucastnika 5 - Iba LSB bajt. MSB sa rovnaju RX_ADDR_P1.
		dt	0xC6			;22 RX_ADDR_P5			RX adresa pre ucastnika 6 - Iba LSB bajt. MSB sa rovnaju RX_ADDR_P1.
		dt	0xE1			;23 TX_ADDR_1			TX adresa - Prvy (LSB) bajt
		dt	0xE2			;24 TX_ADDR_2			TX adresa - Druhy bajt
		dt	0xE3			;25 TX_ADDR_3		TX adresa - Treti bajt
		dt	0xE4			;26 TX_ADDR_4		TX adresa - Stvrty bajt
		dt	0xE5			;27 TX_ADDR_5		TX adresa - Piaty (MSB) bajt
		dt	.0				;28 RX_PW_P0		Ocakavana dlzka dat v pakete (RX) pre ucastnika 1  (0-32Byte)
		dt	.0				;29 RX_PW_P1		Ocakavana dlzka dat v pakete (RX) pre ucastnika 2  (0-32Byte)
		dt	.0				;30 RX_PW_P2		Ocakavana dlzka dat v pakete (RX) pre ucastnika 3  (0-32Byte)
		dt	.0				;31 RX_PW_P3		Ocakavana dlzka dat v pakete (RX) pre ucastnika 4  (0-32Byte)
		dt	.0				;32 RX_PW_P4		Ocakavana dlzka dat v pakete (RX) pre ucastnika 5  (0-32Byte)
		dt	.0				;33 RX_PW_P5		Ocakavana dlzka dat v pakete (RX) pre ucastnika 6  (0-32Byte)
		dt	b'00000001'		;34 DYNPD		Dynamicka dlzka dat: 5:P5(v), 4:P4(v), 3:P3(v), 2:P2(v), 1:P1(v), 0:P0(v)
		dt	b'00000110'		;35 FEATURE			2:Dynamicka dlzka dat, 1:Data s ACK, 0:Aktivacia prikazu W_TX_PAYLOAD_NOACK
		dt	0x00




;===================================================================================================================
;===================================== D E S K R I P T O R Y  ============================================
;===================================================================================================================

;====================================================================================================
;==================================== DEVICE DESCRIPTOR 18 B =======================================
;====================================================================================================

DEVICE_DESKRIPTOR		addwf 	PCL,f

;------------------------------------- DeviceDescriptor 18 B----------------------------------------

		dt	0x12			;BLenght - Velkost deskriptora v bajtoch	18B
		dt	0x01			;bDescriptor type - Typ deskriptora (01h = deskriptor zariadenia)
		dt	0x00,0x02		;BcdUSB - verzia USB (V.1.0)
		dt	0x00			;bDeviceClass - kod triedy zariadenia
		dt	0x00			;bDeviceSubClass - kod podtriedy zariadenia
		dt	0x00			;bDeviceProtocol - kod protokolu
		dt	0x08			;bMaxPacketSize0 - velkost FIFO pre EP0
		dt	VIDL,VIDH		;IdVendor - identifikator dodavatela (058Bh)	VID
		dt	PIDL,PIDH		;IdProduct - identifikator vyrobku (C541h)		PID
		dt	VERL,VERH		;bcdDevice - cislo verzie (V.01) 0001h
		dt	0x01			;iManufactured - index textoveho retazca pre vyrobcu
		dt	0x02			;iProduct -  - index textoveho retazca pre vyrobok	
		dt	0x02		 	;iSerialNumber - index textoveho retazca pre seriove cislo
		dt	0x01			;bNumConfigurations - pocet moznych konfiguracii

;====================================================================================================
;===================================== CONFIGURATION DESCRIPTORS 41 B =======================================
;====================================================================================================

CONFIGURATION_DESKRIPTOR		addwf 	PCL,f

;------------------------------------- ConfigurationDescriptor 9 B ----------------------------------------

		dt	0x09			;bLenght - velkost deskriptora v bajtoch (9)
		dt	0x02			;bDescriptorType - typ deskriptora (02h = konfiguracny deskriptor)
		dt	0x29,0x00		;wTotalLenght -  (41 Bytes) dlzka vsetkych deskriptorov tejto konfiguracie. (0019h)
		dt	0x01			;bNumInterfaces - pocet rozhrani
		dt	0x01			;bConfigurationValue - cislo tejto konfiguracie
		dt	0x00			;iConfiguration - textovy retazec index konfiguracie
		dt	b'10000000'		;bmAttributes - b7 musi byt 1; b6 vlastne napajanie; b5 dialkove prebudenie; b4-0 nastavene do 0
		dt	.50				;MaxPower - Prudovy odber. Jedna jednotka = 2 mA

;------------------------------------- Generic HID Interface descriptor 9B ----------------------------------------

		dt	0x09			;bLenght - velkost deskriptora v bajtoch (9)
		dt	0x04			;bDescriptorType - typ deskriptora (04h = deskriptor rozhrania)
		dt	0x00			;bInterfaceNumber - cislo rozhrania
		dt	0x00			;bAlternateSetting - alternativne nastavenie
		dt	0x02			;nNumEndpoints - Pocet koncovych bodov bez EP0
		dt	0x03			;bInterfaceClass -  (Vendor specific)  trieda rozhrania
		dt	0x00			;bInterfaceSubclass - pripadna podtrieda rozhrania
		dt	0x00			;bInterfaceProtocol - Pripadny kod protokolu
		dt	0x00			;iInterface - retazcovy index

;----------------------------------  Generic Hid Class-Specific descriptor 9B ----------------------------------------

		dt	0x09			;bLength - Vekos deskriptora v bajtoch. (9 bajtov)
		dt	0x21			;bDescriptorType - Typ deskriptora. (21 = HID deskriptor.)
		dt	0x11,0x01		;bcdHID - Verzia HID pecifikcie je 01.11 
		dt	0x00			;bCountryCode - Kd krajiny (Nepodporovan.)
		dt	0x01			;bNumDescriptors - Poet deskriptorov pre triedu HID, ktor maj nasledova.
		dt	0x22			;bDescriptorType - Typ report deskriptora. (Ktor bude nasledova.)
		dt	.25,0x00;.34	;bDescriptorLenght - Dka report deskriptora

;---------------------------------- Generic HID Endpoint 1 In 7B ----------------------------------------

		dt	0x07			;bLength - Vekos deskriptora v bajtoch. (7 bajtov)
		dt	0x05			;bDescriptorType - Typ deskriptora. (05 = Endpoint deskriptor.)
		dt	0x81			;bEndpointAddress - slo endpointu je 1, smer prenosu IN (lebo siedmy bit = 1)
		dt	0x03			;bmAttributes - Typ prenosu endpointu bude preruovac (Interrupt transfer)
		dt	B_CNT_EP1_IN,0x00;wMaxPacketSize - Dka dtovho paketu tohto endpointu.
		dt	0x01			;bInterval - Interval prenosu bude 1 milisekunda.

;---------------------------------- Generic HID Endpoint 1 Out 7B ----------------------------------------

		dt	0x07			;bLength - Vekos deskriptora v bajtoch. (7 bajtov)
		dt	0x05			;bDescriptorType - Typ deskriptora. (05 = Endpoint deskriptor.)
		dt	0x01			;bEndpointAddress - slo endpointu je 1, smer prenosu OUT (lebo siedmy bit = 0)
		dt	0x03			;bmAttributes - Typ prenosu endpointu bude preruovac (Interrupt transfer)
		dt	B_CNT_EP1_OUT,0x00;wMaxPacketSize - Dka dtovho paketu tohto endpointu.
		dt	0x01			;bInterval - Interval prenosu bude 1 milisekunda.

;====================================================================================================
;========================================= REPORT DESCRIPTOR 47-13 =======================================
;====================================================================================================

#ifdef K
	;povodny report deskriptor
REPORT_DESKRIPTOR		addwf 	PCL,f		
		dt	0x06,0x00,0xFF		;Usage Page (Vendor Defined Page 1)
		dt	0x09,0x01			;Usage (Vendor Usage 1)	
		dt	0xA1,0x01			;Collection (Application)				7
	;Input report
		dt	0x09,0x01			;Usage ID - vendor defined
		dt	0x15,0x00			;Logical Minimum (0)
		dt	0x26,0xFF,0x00		;Logical Maximum (255)
		dt	0x75,0x08			;Report Size (8 bits)
		dt	0x95,B_CNT_EP1_IN	;Report Count
		dt	0x81,0x02			;Input (Data, Variable, Absolute)		13
	;Output report
		dt	0x09,0x02			;Usage ID - vendor defined
		dt	0x15,0x00			;Logical Minimum (0)	
		dt	0x26,0xFF,0x00		;Logical Maximum (255)
		dt	0x75,0x08			;Report Size (8 bits)	
		dt	0x95,B_CNT_EP1_OUT	;Report Count
		dt	0x91,0x02			;Input (Data, Variable, Absolute)
		dt	0xC0				;END_COLLECTION							14	=	34
#endif


;#ifdef K
	;zjednoduseny report deskriptor
REPORT_DESKRIPTOR		addwf 	PCL,f			
		dt	0x06,0x00,0xFF		;Usage Page (Vendor Defined Page 1)
		dt	0x09,0x01			;Usage (Vendor Usage 1)	
		dt	0xA1,0x01			;Collection (Application)				
		dt	0x15,0x00			;Logical Minimum (0)
		dt	0x26,0xFF,0x00		;Logical Maximum (255)
		dt	0x75,0x08			;Report Size (8 bits)
		dt	0x95,B_CNT_EP1_IN	;Report Count							16
	;Input report
		dt	0x09,0x01			;Usage ID - vendor defined
		dt	0x81,0x02			;Input (Data, Variable, Absolute)		4
	;Output report
		dt	0x09,0x01			;Usage ID - vendor defined
		dt	0x91,0x02			;Input (Data, Variable, Absolute)
	;end
		dt	0xC0				;END_COLLECTION							5	=	25
;#endif


;====================================================================================================
;========================================= STRING DESCRIPTORY =======================================
;====================================================================================================

;---------------------------------- String Descriptor ID jazyka ----------------------------------------

Language_string		addwf 	PCL,f

	dt	.4
	dt	0x03
	dt	0x09,0x04

;---------------------------------- String Descriptor Manufactured ----------------------------------------

Manufactured_string		addwf 	PCL,f

		dt	.32
		dt	0x03
		dt	'M',0,'o',0,'j',0,'e',0,' ',0,'z',0,'a',0,'r',0,'i',0,'a',0,'d',0,'e',0,'n',0,'i',0,'e',0

;---------------------------------- String Descriptor Vendor ----------------------------------------

Product_string		addwf 	PCL,f

		dt	.46
		dt	0x03
		dt	'P',0,'I',0,'C',0,'1',0,'6',0,'F',0,'1',0,'4',0,'5',0,'4',0,' ',0
		dt	'G',0,'e',0,'n',0,'e',0,'r',0,'i',0,'c',0,' ',0,'H',0,'I',0,'D',0
		; Riadok 186 (max. 255)
	

;***********************************************************************************************************
;************************************** KONFIGURACIA PIC ***************************************************
;***********************************************************************************************************

										;-----u-----;
							;      Vdd+	; Vdd	Vss ; Vss-
							; 	CE		; RA5	RA0 ; 	USB D+  zeleny
							;	IRQ		; RA4	RA1 ; 	USB D-  biely
							;		Vpp	; RA3	3v3 ; VUSB3V3
							; 	SCK		; RC5	RC0 ; PGD
							; 	MOSI	; RC4	RC1 ; PGC
							;	MISO	; RC3	RC2 ;		CSN
										;-----------;
Nastavenie_PIC
			;Vyresetovanie ANSELA priamo na adrese, lebo symbolicka premenna ANSELA nie je implementovana. PortA,4 totiz nefungoval.
		movlw	0x01
		movwf	FSR0H
		movlw	0x8C
		movwf	FSR0L	
		clrf	INDF0
		banksel	ANSELC
		clrf	ANSELC
		banksel	OSCCON
		clrf	OSCTUNE
		movlw	b'11111100'		;nastavenie interneho oscilatora na 48 MHz	
		movwf	OSCCON
		banksel	ACTCON
		movlw	b'10010000'		;The HFINTOSC oscillator is tuned using Fll-speed USB events
		movwf	ACTCON
		banksel	OPTION_REG
		movlw	b'11000011'
		movwf	OPTION_REG
		banksel	TRISA
		movlw	b'00001000'
		movwf	TRISC
		movlw	b'00011000'
		movwf	TRISA
		banksel	LATC
		clrf	LATA
		clrf	LATC

		banksel	APFCON

;		movlw	b'10001000'
;		movwf	APFCON

		banksel	IOCAN
		movlw	b'00010000'
		movwf	IOCAN


		banksel	WDTCON
		;movlw	b'00100101'		;256s bit 5-1 prescale; bit 0 on/off
		;movlw	b'00100011'		;128s bit 5-1 prescale; bit 0 on/off
		;movlw	b'00100001'		;64s bit 5-1 prescale; bit 0 on/off
		;movlw	b'00011111'		;32s bit 5-1 prescale; bit 0 on/off
		;movlw	b'00011101'		;16s bit 5-1 prescale; bit 0 on/off
		;movlw	b'00011011'		;8s bit 5-1 prescale; bit 0 on/off
		;movlw	b'00011001'		;4s bit 5-1 prescale; bit 0 on/off
		movlw	b'00010110'		;2s bit 5-1 prescale; bit 0 on/off
		;movlw	b'00010101'		;1s bit 5-1 prescale; bit 0 on/off
		;movlw	b'00010011'		;512ms bit 5-1 prescale; bit 0 on/off
		;movlw	b'00010001'		;256ms 5-1 prescale; bit 0 on/off
		;movlw	b'00001111'		;128ms bit 5-1 prescale; bit 0 on/off
		;movlw	b'00001101'		;64ms bit 5-1 prescale; bit 0 on/off
		;movlw	b'00001011'		;32ms bit 5-1 prescale; bit 0 on/off
		;movlw	b'00001001'		;16ms bit 5-1 prescale; bit 0 on/off
		;movlw	b'00000111'		;8ms bit 5-1 prescale; bit 0 on/off
		;movlw	b'00000101'		;4ms bit 5-1 prescale; bit 0 on/off
		;movlw	b'00000011'		;2ms bit 5-1 prescale; bit 0 on/off
		;movlw	b'00000001'		;1ms bit 5-1 prescale; bit 0 on/off
		movwf	WDTCON			; nastavenie WATCHDOG
		banksel PORTA
	return



vycistenie_GPR_banky_0
		movlw	.80				; 80 bajtov GPR v kazdej banke
		movwf	020h
		clrf	FSR0H
		movlw	020h+1 			; druhy bajt GPR banky 0 (prvy bajt je pocitadlo)
		movwf	FSR0L
	opakuj_nulovanie_bajtov_0
		movlw	.0
		movwf	INDF0
		incf	FSR0L,f
		decfsz	020h,f
		goto	opakuj_nulovanie_bajtov_0
		clrf	020h
	return


	;Vynulovanie 256 bajtov linearnej RAM urcenej pre volne pouzitie (od banky 7)
Clear_linear_RAM
		movlw	0xFF		
		movwf	TMP
		movlw	ADR_H_Rx
		movwf	FSR0H
		movlw	ADR_L_Rx
		movwf	FSR0L
	opakuj_nulovanie_bajtov_2
		clrf	INDF0
		incf	FSR0L,f
		decfsz	TMP,f
		goto	opakuj_nulovanie_bajtov_2
	return



vycistenie_RAM_EP1_OUT
		movlw	B_CNT_EP1_OUT
		movwf	030h
		movlw	ADR_H_EP1_OUT
		movwf	FSR0H
		movlw	ADR_L_EP1_OUT
		movwf	FSR0L
	opakuj_nulovanie_bajtov_EP1_OUT
		movlw	.0
		movwf	INDF0
		incf	FSR0L,f
		decfsz	030h,f
		goto	opakuj_nulovanie_bajtov_EP1_OUT
	return



vycistenie_RAM_EP1_IN
		movlw	B_CNT_EP1_IN
		movwf	030h
		movlw	ADR_H_EP1_IN
		movwf	FSR0H
		movlw	ADR_L_EP1_IN
		movwf	FSR0L
	opakuj_nulovanie_bajtov_EP1_IN
		movlw	.0
		movwf	INDF0
		incf	FSR0L,f
		decfsz	030h,f
		goto	opakuj_nulovanie_bajtov_EP1_IN
	return



vycistenie_RAM_EP0_OUT
		movlw	.16
		movwf	030h
		movlw	ADR_H_EP0_OUT_setup
		movwf	FSR0H
		movlw	ADR_L_EP0_OUT_setup
		movwf	FSR0L
	opakuj_nulovanie_bajtov_EP0_OUT
		movlw	.0
		movwf	INDF0
		incf	FSR0L,f
		decfsz	030h,f
		goto	opakuj_nulovanie_bajtov_EP0_OUT
	return




;***********************************************************************************************************
;******************************************** PAUZY ********************************************************
;***********************************************************************************************************


pauza		
		movwf	N100
p10		movlw	.100	
		movwf	N10
p1		movlw	.100
		movwf	N1
		decfsz	N1,f
		goto	$-1
		decfsz	N10,f
		goto	p1
		decfsz	N100,f
		goto	p10
	return			



;Pauza podla vzorca y = 5+3x, kde y je pocet instrukcnych cyklov a x je cislo na vstupe do W reg..
;Cize cas T = (5+3x)*4/Fosc
;Cize cas T = (5+3x)*4/48000000
; 1T = 0.67 us
; 1 ic = 0.125 us (x = 1 = 8ic = 1us)


cakaj_x					
		movwf	TMP_P1
		decfsz	TMP_P1,f
		goto	$-1
		clrwdt
	return


Pauza_1us
		movlw	.3			;1.17us
		call	cakaj_x
	return




Pauza_200us
		movlw	.4				; 4 * 50,167 us = 200,67
		movwf	TMP_P2
	p_200us
		movlw	.199			; .199 = 50,167 us
		call	cakaj_x
		decfsz	TMP_P2
		goto	p_200us
	return



Pauza_1ms
		movlw	.5
		movwf	TMP_P3
	p_1ms
		call	Pauza_200us
		decfsz	TMP_P3
		goto	p_1ms
	return



Pauza_10ms
		movlw	.50
		movwf	TMP_P3
	p_10ms
		call	Pauza_200us
		decfsz	TMP_P3
		goto	p_10ms
	return



Pauza_20ms
		movlw	.100
		movwf	TMP_P3
	p_20ms
		call	Pauza_200us
		decfsz	TMP_P3
		goto	p_20ms
	return



Pauza_100ms
		movlw	.10
		movwf	TMP_P4
	p_100ms
		call	Pauza_10ms
		decfsz	TMP_P4
		goto	p_100ms
	return



Pauza_200ms
		movlw	.10
		movwf	TMP_P4
	p_200ms
		call	Pauza_20ms
		decfsz	TMP_P4
		goto	p_200ms
	return




;***********************************************************************************************************
;****************************************** PODPROGRAMY USB ************************************************
;***********************************************************************************************************



Inicializacia_USB
		banksel	UCFG
		movlw	b'00010100'		;UPUEN, FSEN
		movwf	UCFG
		clrf	UADDR
		clrf	UEIR
		bcf		UCON,PKTDIS
			;Status zariadenia
		banksel	AktualnaKonfiguracia
		clrf	AktualnaKonfiguracia
		banksel	PORTA
	return



Zapnutie_USB_modulu
		banksel	UCON
		movlw	b'00001000'
		movwf	UCON
			;Cakaj na pociatocne zapnutie, kym nebude nula na zbernici
		btfsc	UCON,SE0
		goto	$-1
		banksel	PORTA
	return



Aktivacia_preruseni
		banksel	UIE
		clrf	UIR
		movlw	b'00001001'		; Enable interrupt:  TRNIE, URSTIE
		movwf	UIE
		banksel	INTCON
		movlw	b'11001000'		;Aktivacia preruseni: GIE(7), PEIE(6), IOCIE(3)
		movwf	INTCON
		banksel	PIE2
		bsf		PIE2,USBIE		;Enables the USB interrupt
		banksel	PORTA
	return



Prerusenia_USB
		;-----------------------------------------URSTIF-------------------------------------------------
			;Obsluha_URSTIF (RESETu)
		banksel	UIR
		btfss	UIR,URSTIF
		goto	preskoc_usb_reset
		btfss	UIE,URSTIE
		goto	preskoc_usb_reset
			clrf	UEIR
			clrf	UIR
			clrf	UEIE
			movlw	b'00001001'		; TRNIE, URSTIE
			movwf	UIE
			clrf	UADDR
			movlw	b'00010110'		; EPINEN, EPOUTEN, EPHSHK
			movwf	UEP0
				;Cyklicke nulovanie priznaku TRNIF od pripadnej predoslej prijatej paketovej sekvencie.
			bcf		UIR,TRNIF
			btfsc	UIR,TRNIF
			goto	$-2
				;Odblokovanie endpointu 0 po predoslom pripadnom prijati SETUP tokenu.
			bcf		UCON,PKTDIS
				;Prvotne cakanie na OUT token od PC (po RESETe).
			call	Aktivacia_EP0_OUT_prenosu_z_PC
				 	; Reset premennych vyuzivanych v programe:
			banksel	AktualnaKonfiguracia
			clrf	AktualnaKonfiguracia
			clrf	ADRESA
			clrf	DESC		;vypinace deskriptorov
			clrf	POZICIA		;posun po polozkach deskriptora
			bcf		Ziadost_spracovana			;info o spracovani znamej ziadosti z PC
			clrf	Pocet_byte_z_deskriptora	;nacita z deskriptora jeho dlzku
					;vynulovanie priznaku ktory vyvolal toto prerusenie (abz sa sem cyklicky nebehalo).
			banksel	UIR
			bcf		UIR,URSTIF
			preskoc_usb_reset
			banksel	PORTA
		;---------------------------------------TRNIF-------------------------------------------------
			;Obsluha_TRNIF - Datove prenosy
		banksel	UIR
		btfss	UIR,TRNIF
		goto	preskoc_spracovanie_dat
		btfss	UIE,TRNIE
		goto	preskoc_spracovanie_dat
		banksel	PORTA
			call	Riadiace_prenosy
			banksel	UIR
			bcf		UIR,TRNIF
			clrf	UIR
		preskoc_spracovanie_dat
		banksel	PORTA
		;--------------------------------------USBIF clear-------------------------------------------------
		banksel	PIR2
		bcf		PIR2,USBIF
		banksel	UEIR
		clrf	UEIR
		banksel	PORTA
	return



;========================================================================================================
;==========================================================================================================
;=================== Obsluha USB prerusenia TRNIF od dokoncenej paketovej sekvencie. ======================================
;========================================================================================================
;========================================================================================================


	;Korenovy podprogram.
Riadiace_prenosy
		call	Nacitanie_USB_STATUS_registra
		call	Nacitanie_paketu_do_premennych
;		call	Nacitanie_USB_STATUS_registra
		banksel	Naposledy_aktivny_endpoint
			;Obsluha aktivity endpointu 0.=============================================================
		movlw	Endpoint_0
		subwf	Naposledy_aktivny_endpoint,w		
		btfss	STATUS,Z
		return
			;Odstavenie hlavneho programu, ked sa objavila aktivita na endpointe 0 (nastavovacie prenosy).
		banksel	PORTA
		bcf		Povolenie_USB			;reset bitu spustajuceho komunikaciu na EP1
		banksel	Posledny_smer_prenosu
				;Nastal smer prenosu PC >>>>> PIC (OUT).================================================
			movlw	Posledny_bol_token_OUT_al_SETUP	
			subwf	Posledny_smer_prenosu,w
			btfss	STATUS,Z
			goto	preskoc_out_or_setup
					;Obsluha iba SETUP tokenu.==========================================================
				movf	PID_paketu,w
				sublw	SETUP_Token
				btfss	STATUS,Z
				goto	preskoc_setup
						;Reset pomocnych premennych 
					clrf	DESC		;vypinace deskriptorov
					clrf	POZICIA		;posun po polozkach deskriptora
					bcf		Ziadost_spracovana			;info o spracovani znamej ziadosti z PC
					clrf	Pocet_byte_z_deskriptora	;nacita z deskriptora jeho dlzku
					clrf	Pocet_Byte_EP0_IN			;Vynulovanie dlzky paketu EP_0 IN
						;Vyhodnotenie dat zo SETUP paketu a obsluha prislusnej ziadosti.
					call	Ziadosti_do_smeru_Device_to_Host
					call	Ziadosti_do_smeru_Host_to_Device
						;Ak sa objavila znama ziadost, vloz do RAM prvy paket k odoslaniu...
						;...a aktivuj EP0_IN. Jednotka SIE ho posle do PC hned, ako PC posle IN token.
						;Ak treba poslat viac paketov, pokracuje sa uz v sekcii: "Posledny_bol_token_IN".
 						;Ak ziadost nema obsluhu, nastav EP0_IN na STALL (zastaveny).
					btfss	Ziadost_spracovana
					goto	Preskoc_znamu_ziadost
						call	Aktivacia_EP0_OUT_prenosu_z_PC	;Znovu pripravi EP0_OUT na buduci prijem.
						call	Rozdelovanie_dat_po_8_Byte		;Vlozenie odpovede (paketu) do RAM EP0_IN.
						call	Aktivacia_EP0_IN_prenosu_do_PC	;Odovzdanie EP0_IN do vlastnictva SIE.
					goto	preskoc_neznamu_ziadost
					Preskoc_znamu_ziadost
						call	Nastavenie_EP0_OUT_na_STALL		;Odmietnutie ziadosti. SIE odpovie STALL paketom.
					preskoc_neznamu_ziadost
						;Zapnutie paketovych prenosov. SETUP token ich totiz vzdy zablokuje nastavenim bitu "PKTDIS" do 1.
						;Enable SIE token and packet processing
					banksel	UCON
					bcf   UCON,PKTDIS
					banksel	Stadium_procesu
				preskoc_setup
		preskoc_out_or_setup
			;Nastal smer prenosu PIC >>>>> PC (IN).=====================================================
		banksel	Posledny_smer_prenosu
		movlw	Posledny_bol_token_IN
		subwf	Posledny_smer_prenosu,w				
		btfss	STATUS,Z
		goto	preskoc_in_token
				;Vynulovanie dlzky paketu EP_0 IN
			clrf	Pocet_Byte_EP0_IN			
				;Ziadost na pridelenie adresy posielana na zaciatku enumeracie sa musi vykonat az po...
				;...dokoceni SETUP transferu. -V potvrdzujucom IN transferi obsahujucom prazdny paket.
				;Vlozenie ziskanej adresy do pracovneho USB registra.
			movlw	ADDRESS
			subwf	Stav_zariadenia,w
			btfss	STATUS,Z
			goto	preskoc_nastavenie_adresy
				movf	ADRESA,w
				banksel	UADDR
				movwf	UADDR
				banksel	Stadium_procesu
				movlw	ENUMERACIA
				movwf	Stav_zariadenia
				bcf		Ziadost_spracovana
			preskoc_nastavenie_adresy
			call	Rozdelovanie_dat_po_8_Byte		;Vlozenie dalsieho paketu do RAM EP0_IN.
			call	Aktivacia_EP0_IN_prenosu_do_PC	;Odovzdanie EP0_IN do vlastnictva SIE.
		preskoc_in_token
	return



;======================================================================================================
;Bajty SETUP transferu: ===============================================================================
;bmRequestType	bRequest	wValue0		wValue1		wIndex0		wIndex1		wLength_LSB		wLength_MSB	
;======================================================================================================


;======================================================================================================
;=============================== Smery poziadaviek. (bmRequestType,bit7) ==============================
;======================================================================================================


Ziadosti_do_smeru_Device_to_Host
		movf	Smer_poziadavky,w
		sublw	Device_to_Host
		btfss	STATUS,Z
		return	
		call	Typ_Standard
	return



Ziadosti_do_smeru_Host_to_Device
		movf	Smer_poziadavky,w
		sublw	Host_to_Device
		btfss	STATUS,Z
		return	
		call	Typ_Class
		call	Typ_Standard
	return


;======================================================================================================
;================================= Typy poziadaviek. (bmRequestType,bity6-5) ==========================
;======================================================================================================


Typ_Standard
		movf	Typ_poziadavky,w
		sublw	Standard
		btfss	STATUS,Z
		return
		call	Prijemca_Device
		call	Prijemca_Interface
	return



Typ_Class
		movf	Typ_poziadavky,w
		sublw	Class
		btfss	STATUS,Z
		return
		call	Prijemca_Interface
	return


;======================================================================================================
;============================== Prijemca poziadaviek. (bmRequestType,bity4-0) =========================
;======================================================================================================


Prijemca_Device
		movf	Prijemca_poziadavky,w
		sublw	Device
		btfss	STATUS,Z			
		return
		call	Poziadavka_GET_DESCRIPTOR
		call	Poziadavka_SET_ADDRESS
		call	Poziadavka_SET_CONFIGURATION
		call	Poziadavka_GET_CONFIGURATION
	return



Prijemca_Interface
		movf	Prijemca_poziadavky,w
		sublw	Interface
		btfss	STATUS,Z			
		return
		call	Poziadavka_GET_DESCRIPTOR
		call	Poziadavka_GET_INTERFACE
		call	Poziadavka_SET_INTERFACE
	return



;======================================================================================================
;======================================= Poziadavky. (bRequest) =======================================
;======================================================================================================



Poziadavka_GET_DESCRIPTOR
			;Ak prisla z PC poziadavka na odoslanie nejakeho deskriptora (tj. "bRequest"==0x06),....
		movlw	GET_DESCRIPTOR	
		subwf	Poziadavka,w
		btfss	STATUS,Z
		return
		call	Get_Device_descriptor
		call	Get_Configuration_descriptor
		call	Get_String_descriptors
		call	Get_Report_descriptor
	return



Poziadavka_SET_ADDRESS
		movlw	SET_ADDRESS	
		subwf	Poziadavka,w
		btfss	STATUS,Z
		return
				;...nacitaj z tretieho bajtu PC SETUP paketu ("wValue0") hodnotu adresy do internej premennej.
			movf	Hodnota0_poziadavky,w
			movwf	ADRESA
				;Vloz do internej premennej informaciu o stave zariadenia, ze sa prideluje adresa.
			movlw	ADDRESS
			movwf	Stav_zariadenia		; Stav zariadenia je bud ADRESS alebo NAKONFIGUROVANE (=nakonfigurovane).
				;Zapni priznak informujuci o spracovani znamej ziadosti z PC
			bsf		Ziadost_spracovana				
	return



Poziadavka_SET_CONFIGURATION
		;-----------------------------------------------SET_CONFIGURATION----------------------------------------------------------
		;--- PC vyzve zariadenie na nastavenie konfiguracie zaslanim jej cisla ------------------
		;---- uvedeneho v deskriptore konfiguracie. -Odvtedy je zariadenie povazovane za -------
		;---- nakonfigurovane a pracovny endpoint aktivny. ...Pri nule sa vsak treba  ---------------------------
		;----- vratit spat do stavu zariadenia = ADRESA. ----------------------------------------
		;=============================================================================================
			;Ak prisla z PC poziadavka na nastavenie konfiguracie (tj. "bRequest"==0x09),....
		movlw	SET_CONFIGURATION	
		subwf	Poziadavka,w
		btfss	STATUS,Z
		return
				;Zapni priznak informujuci o spracovani znamej ziadosti z PC
			bsf		Ziadost_spracovana
				;PC SETUP paket teraz vo wValue0 oznamuje cislo aktualnej konfiguracie, ktore davam do int. premennej
			movf	Hodnota0_poziadavky,w
			movwf	AktualnaKonfiguracia
				;Ak je hodnota konfigurcie nula, zariadenie sa uvedie do stavu adresy (USB 2.0 - 9.4.7)
				;(Uistite sa, e nov hodnota konfigurcie je t, ktor existuje v deskriptore.)	
			btfss	STATUS,Z
			goto	preskoc_CurrentConfiguration
					;status zariadenia
				movlw	ADDRESS					;AktualnaKonfiguracia = ADRESS
				movwf	Stav_zariadenia
			return
			preskoc_CurrentConfiguration
				;Ak cislo pridelenej konfiguracie z PC SETUP paketu nesedi s bConfigurationValue....
				;...v CONFIGURATION_DESKRIPTORe, preskoc inicializaciu HID endpointu 1.
			movlw	.6-.1
			call	CONFIGURATION_DESKRIPTOR
			subwf	AktualnaKonfiguracia
			btfss	STATUS,Z
			return
				;Ak hodnota konfigurcie nie je nula, zariadenie sa uvedie do stavu 'nakonfigurovane'
				movlw	NAKONFIGUROVANE
				movwf	Stav_zariadenia
				call	Aktivacia_EP1_IN_OUT
	return



Poziadavka_GET_INTERFACE
			;Vybavenie poziadavky GET_INTERFACE
		movlw	GET_INTERFACE
		subwf	Poziadavka,w
		btfss	STATUS,Z
		return
				;Zapni priznak informujuci o spracovani znamej ziadosti z PC
			bsf		Ziadost_spracovana
				;iadna podpora pre alternatvne rozhrania. Odoli nulu sp hostovi.
			banksel	USB_RAM0_BYTE_1_IN
			clrf	USB_RAM0_BYTE_1_IN
				;pocet bajtov, ktore sa budu prenasat cez kontrolny endpoint 0
			movlw	.1
			movwf	Pocet_Byte_EP0_IN			;Nastavenie dlzky paketu EP_0 IN
	return



Poziadavka_SET_INTERFACE
		movlw	SET_INTERFACE	
		subwf	Poziadavka,w
		btfss	STATUS,Z
		return
				;Zapni priznak informujuci o spracovani znamej ziadosti z PC
			bsf		Ziadost_spracovana
	return



Poziadavka_GET_CONFIGURATION
		movlw	GET_CONFIGURATION	
		subwf	Poziadavka,w
		btfss	STATUS,Z
		return
				;Zapni priznak informujuci o spracovani znamej ziadosti z PC
			bsf		Ziadost_spracovana
				;Nacitanie cisla aktualnej konfiguracie z globalnej premennej
			movf	AktualnaKonfiguracia,w
			banksel	USB_RAM0_BYTE_1_IN
			movwf	USB_RAM0_BYTE_1_IN	; outPtr	Odosle sa Hostovi 1 bajt
				;pocet bajtov, ktore sa budu prenasat cez kontrolny endpoint 0
			movlw	0x01
			movwf	Pocet_Byte_EP0_IN			;Nastavenie dlzky paketu EP_0 IN
	return



;======================================================================================================
;========================== Konecne poziadavky (...na deskriptory, etc.). (wValue1) =============================
;======================================================================================================



Get_Report_descriptor
			;REPORT_DESCRIPTOR
		movlw	REPORT_DESCRIPTOR
		subwf	Hodnota1_poziadavky,w
		btfss	STATUS,Z
		return
				;Zapni priznak informujuci o spracovani znamej ziadosti z PC
			bsf		Ziadost_spracovana
				;Je nacitany z HID deskriptora, kde je tato dlzka definovana.
			movlw	.26-.1	;Odpocet jednotky, lebo pozicia 0 je prvy bajt
			call	CONFIGURATION_DESKRIPTOR
			movwf	Pocet_byte_z_deskriptora
				;Typ prenossu: 1-rom(deskriptory), 0-ram(data priamo z ram)
			bsf		REPORT_DESC
	return



Get_Device_descriptor
			;Ak wValue1 pozaduje deskriptor zariadenia (hodnota 0x01),...
		movlw	DEVICE_DESCRIPTOR
		subwf	Hodnota1_poziadavky,w
		btfss	STATUS,Z
		return
				;Nacitaj do int. premennej dlzku deskriptora zariadenia, ktora je v nom na prvej pozicii. (18 B)
			movlw	.1-.1				;(Odpocitaj 1, lebo pozicia 0 je prvy bajt)
			call	DEVICE_DESKRIPTOR
			movwf	Pocet_byte_z_deskriptora
				;Zapni priznak informujuci o spracovani znamej ziadosti z PC
			bsf		Ziadost_spracovana
				;Zapni priznak deskriptora zariadenia, aby sa pri prenose ukladal do RAM EP0.
			bsf		DEVICE_DESC
	return



Get_Configuration_descriptor
			;Ak wValue1 pozaduje deskriptor konfiguracie (hodnota 0x02),...
		movlw	CONFIGURATION_DESCRIPTOR
		subwf	Hodnota1_poziadavky,w
		btfss	STATUS,Z
		return
				;Nacitaj do int. premennej celu dlzku deskriptora konfiguracie, ktora je v nom na tretej pozicii. (41 B)
				;(Deskriptor konfiguracie sa totiz sklada z HIDinterface + HIDdesc + EndpointDesc.)
			movlw	.3-.1				;(Odpocitaj 1, lebo pozicia 0 je prvy bajt)
			call	CONFIGURATION_DESKRIPTOR
			movwf	Pocet_byte_z_deskriptora
				;Zapni priznak informujuci o spracovani znamej ziadosti z PC
			bsf		Ziadost_spracovana
				;Zapni priznak deskriptora konfiguracie, aby sa pri prenose ukladal do RAM EP0.
			bsf		CONFIGURATION_DESC
	return



Get_String_descriptors
			;Ak wValue1 pozaduje textovy deskriptor (hodnota 0x03),...
		movlw	STRING_DESCRIPTOR
		subwf	Hodnota1_poziadavky,w
		btfss	STATUS,Z
		return
			;--------------------------------------------STRING_0----------------------------------------------------------------------
				;...ak wValue0 pozaduje textovy deskriptor s indexom 0x00,...
			movlw	0x00
			subwf	Hodnota0_poziadavky,w
			btfss	STATUS,Z
			goto	preskoc_StringDescriptor0
					;Nacitaj do int. premennej dlzku textoveho deskriptora indexu 0x00, ktora je v nom na prvej pozicii. (4 B)
				movlw	.1-.1				;(Odpocitaj 1, lebo pozicia 0 je prvy bajt)
				call	Language_string
				movwf	Pocet_byte_z_deskriptora
					;Zapni priznak informujuci o spracovani znamej ziadosti z PC
				bsf		Ziadost_spracovana
					;Zapni priznak textoveho deskriptora indexu 0x00, aby sa pri prenose ukladal do RAM EP0.
				bsf		STRING_LANG_DESC
			preskoc_StringDescriptor0
			;--------------------------------------------STRING_1----------------------------------------------------------------------
				;...ak wValue0 pozaduje textovy deskriptor s indexom 0x01,...
			movlw	0x01
			subwf	Hodnota0_poziadavky,w
			btfss	STATUS,Z
			goto	preskoc_StringDescriptor1
					;Nacitaj do int. premennej dlzku textoveho deskriptora indexu 0x01, ktora je v nom na prvej pozicii. 
				movlw	.1-.1			;(Odpocitaj 1, lebo pozicia 0 je prvy bajt)
				call	Manufactured_string
				movwf	Pocet_byte_z_deskriptora
					;Zapni priznak informujuci o spracovani znamej ziadosti z PC
				bsf		Ziadost_spracovana
					;Zapni priznak textoveho deskriptora indexu 0x01, aby sa pri prenose ukladal do RAM EP0.
				bsf		STRING_MANUFACT_DESC
			preskoc_StringDescriptor1
			;--------------------------------------------STRING_2----------------------------------------------------------------------
				;...ak wValue0 pozaduje textovy deskriptor s indexom 0x02,...
			movlw	0x02
			subwf	Hodnota0_poziadavky,w
			btfss	STATUS,Z
			goto	preskoc_StringDescriptor2
					;Nacitaj do int. premennej dlzku textoveho deskriptora indexu 0x01, ktora je v nom na prvej pozicii. 
				movlw	.1-.1			;(Odpocitaj 1, lebo pozicia 0 je prvy bajt)
				call	Product_string
				movwf	Pocet_byte_z_deskriptora
					;Zapni priznak informujuci o spracovani znamej ziadosti z PC
				bsf		Ziadost_spracovana
					;Zapni priznak textoveho deskriptora indexu 0x02, aby sa pri prenose ukladal do RAM EP0.
				bsf		STRING_VENDOR_DESC
			preskoc_StringDescriptor2
		preskoc_textove_teskriptory
	return


;======================================================================================================
;===================================== System posielania po 8 Byte ===============================================
;======================================================================================================


	;SETUP paket je vzdy 8 bajtovy
	;OUT paket ma vzdy prazdne data a sluzi na zaverecne potvrdenie platnosti datovej skupiny.
	;IN paket oznamuje PIC procesoru, ze moze vysielat/pokracovat vo vysielani datovych paketov.

Rozdelovanie_dat_po_8_Byte
			;Ak nie je nacitany ziadny deskriptor, preskoc cyklus nacitavania deskriptora do RAM EP0 IN
		movf	Pocet_byte_z_deskriptora,w
		btfsc	STATUS,Z
		return
			;Ak SETUP paket pozaduje menej byte nez ma prislusny deskriptor, treba poslat kolko pozaduje.
		movf	Pozadovany_pocet_byte,w
		btfsc	STATUS,Z
		goto	preskoc_wLenght_DLZKA
		movf	Pocet_byte_z_deskriptora,w
		subwf	Pozadovany_pocet_byte,w		; wLength_LSB	f - w -> w	wLength_LSB - Pocet_byte_z_deskriptora -> w
		btfsc	STATUS,C					;if(wLength_LSB - Pocet_byte_z_deskriptora) < 0 then C=0
		goto	preskoc_wLenght_DLZKA
			movf	Pozadovany_pocet_byte,w
			movwf	Pocet_byte_z_deskriptora
		preskoc_wLenght_DLZKA
			;Nastavenie ukazatela na zaciatok pamate RAM endpointu 0 IN. (Smer do PC.)
		movlw	ADR_H_EP0_IN_control
		movwf	FSR0H
		movlw	ADR_L_EP0_IN_control
		movwf	FSR0L
			;Nastav pocitadlo na prednastavenu dlzku paketu EP0_IN (8 byte)
		movlw	B_CNT_EP0_IN
		movwf	count
			;Nacitavanie poloziek deskriptorov do RAM EP0_IN po balikoch dlzky 8 byte prip. mensi zvysok.
		opakuj_prenos_do_RAM
				;Linearne inkrementujuca sa premenna, zabezpecujuca posun po vsetkych cislach deskriptora.
			movf	POZICIA,w
				;Zapnutie prislusneho deskritora, ktory sa ma nacitavat do RAM EP0 IN
			btfsc	DEVICE_DESC
			call	DEVICE_DESKRIPTOR
			btfsc	CONFIGURATION_DESC
			call	CONFIGURATION_DESKRIPTOR
			btfsc	REPORT_DESC
			call	REPORT_DESKRIPTOR
			btfsc	STRING_LANG_DESC
			call	Language_string
			btfsc	STRING_MANUFACT_DESC
			call	Manufactured_string
			btfsc	STRING_VENDOR_DESC
			call	Product_string
				;Vlozenie prave nacitanej hodnoty z deskriptora na aktualnu adresu.
			movwf	INDF0
				;Inkrementuj na dalsi riadok deskriptora = na dalsiu hodnotu.
			incf	POZICIA,f
				;Inkrementuj adresu EP0_IN.
			incf	FSR0L,f
				;inkrementuj dlzku paketu EP0_IN (max. 8 byte alebo menej, ak zostal este nejaky zvysok)
			incf	Pocet_Byte_EP0_IN,f
				;dekrementuj udaj o dlzke deskriptora. Ak dosiahne nulu, ukonci nacitavanie cisel deskriptora do RAM EP0_IN.
			decf	Pocet_byte_z_deskriptora,f
			btfsc	STATUS,Z
			return
			;Opakuj 8x nacitavanie cisel deskriptora do RAM EP0_IN.
		decfsz	count,f
		goto	opakuj_prenos_do_RAM
	return




Nacitanie_paketu_do_premennych
			;Rozdelenie bmRequestType do viacerych premennych
		banksel	bmRequestType
		movf	bmRequestType,w
		andlw	b'10000000'
		banksel	Smer_poziadavky
		movwf	Smer_poziadavky
		bcf		STATUS,C
		rlf		Smer_poziadavky,f
		rlf		Smer_poziadavky,f
		banksel	bmRequestType
		movf	bmRequestType,w
		andlw	b'01100000'
		banksel	Typ_poziadavky
		movwf	Typ_poziadavky
		bcf		STATUS,C
		rlf		Typ_poziadavky,f
		rlf		Typ_poziadavky,f
		rlf		Typ_poziadavky,f
		rlf		Typ_poziadavky,f
		banksel	bmRequestType
		movf	bmRequestType,w
		andlw	b'00011111'
		banksel	Prijemca_poziadavky
		movwf	Prijemca_poziadavky
			;Nacitanie ostatnych bajtov SETUP paketu do internych premennych
		banksel	bRequest	
		movf	bRequest,w
		banksel	Poziadavka
		movwf	Poziadavka
		banksel	wValue0	
		movf	wValue0,w
		banksel	Hodnota0_poziadavky
		movwf	Hodnota0_poziadavky
		banksel	wValue1	
		movf	wValue1,w
		banksel	Hodnota1_poziadavky
		movwf	Hodnota1_poziadavky
		banksel	wIndex0	
		movf	wIndex0,w
		banksel	Index0_poziadavky
		movwf	Index0_poziadavky
		banksel	wLength_LSB	
		movf	wLength_LSB,w	
		banksel	Pozadovany_pocet_byte
		movwf	Pozadovany_pocet_byte
			; Nacitanie PID (Paket ID) OUT paketu do internej premennej.
		banksel	BD0STAT_OUT
		movf	BD0STAT_OUT,w
		andlw	b'00111100'
		banksel	PID_paketu
		movwf	PID_paketu
		bcf		STATUS,C
		rrf		PID_paketu,f
		rrf		PID_paketu,f
	return



Nacitanie_USB_STATUS_registra
			;Rozdelenie USTAT do viacerych premennych
		banksel	USTAT
		movf	USTAT,w
		andlw	b'01111000'
		banksel	Naposledy_aktivny_endpoint
		movwf	Naposledy_aktivny_endpoint
		bcf		STATUS,C
		rrf		Naposledy_aktivny_endpoint,f
		rrf		Naposledy_aktivny_endpoint,f
		rrf		Naposledy_aktivny_endpoint,f
		banksel	USTAT
		movf	USTAT,w
		andlw	b'00000100'
		banksel	Posledny_smer_prenosu
		movwf	Posledny_smer_prenosu
		bcf		STATUS,C
		rrf		Posledny_smer_prenosu,f
		rrf		Posledny_smer_prenosu,f
	return



;========================================================================================================
;===================================== Aktivacia/zastavenie endpointov. ==================================
;================== Samotny prenos sa uskutocni az ked PC posle IN, OUT al. SETUP paket.=================
;========================================================================================================


Nastavenie_EP0_OUT_na_STALL
		movlw	B_CNT_EP0_OUT
		banksel	BD0CNT_OUT
		movwf	BD0CNT_OUT 	
		movlw	ADR_L_EP0_OUT_setup		;  PTR16(&SetupPacket);
		movwf	BD0ADRL_OUT	
		movlw	ADR_H_EP0_OUT_setup
		movwf	BD0ADRH_OUT
		movlw	b'10000100'			;  UOWN | BSTALL
		movwf	BD0STAT_OUT
		movlw	b'10000100'			;  UOWN | BSTALL
		movwf	BD0STAT_IN
		banksel	Pocet_Byte_EP0_IN
	return



Aktivacia_EP0_OUT_prenosu_z_PC
		movlw	B_CNT_EP0_OUT
		banksel	BD0CNT_OUT
		movwf	BD0CNT_OUT 	
		movlw	ADR_L_EP0_OUT_setup		;PTR16(&SetupPacket)
		movwf	BD0ADRL_OUT
		movlw	ADR_H_EP0_OUT_setup
		movwf	BD0ADRH_OUT
			; Nastav paket ako DAT0 a odovzdaj bufer jednotke SIE
		movlw	b'10001000'		;  UOWN | DTSEN
		movwf	BD0STAT_OUT
		clrf	BD0STAT_IN
		banksel	Pocet_Byte_EP0_IN
	return



Aktivacia_EP0_IN_prenosu_do_PC
		banksel	Pocet_Byte_EP0_IN
		movf	Pocet_Byte_EP0_IN,w
		banksel	BD0CNT_IN
		movwf	BD0CNT_IN
		movlw	ADR_L_EP0_IN_control
		movwf	BD0ADRL_IN
		movlw	ADR_H_EP0_IN_control
		movwf	BD0ADRH_IN
	;***************Logika odosielania dat - raz DAT1, raz DAT0******************
			;Ak (BD0STAT_IN.DTS == 1) ->> paket bude DAT_1
		banksel	BD0STAT_IN
		btfss	BD0STAT_IN,6
		goto	preskoc_vysielanie_DAT_0_IN
			movlw	b'10001000'			;UOWN | DTSEN
			movwf	BD0STAT_IN
		return
		preskoc_vysielanie_DAT_0_IN
			;Ak (BD0STAT_IN.DTS == 0) ->> paket bude DAT_0
			movlw	b'11001000'			;UOWN | DTS | DTSEN
			movwf	BD0STAT_IN
		banksel	Pocet_Byte_EP0_IN
	return



Aktivacia_EP1_IN_OUT
			;Zapnutie endpointov 1 in a 1 out, zapnutie handshake paketov, vypnutie SETUP paketov pre ne.
		movlw	b'00011110'		; EPINEN, EPCONDIS, EPOUTEN, EPHSHK
		banksel	UEP1
		movwf	UEP1
			;Po dokonceni konfiguracie sa inicializuju koncove body (napr. Priradenie adresy vyrovnvacej pamte).
		movlw	B_CNT_EP1_OUT
		banksel	BD1CNT_OUT
		movwf	BD1CNT_OUT 	
		movlw	ADR_L_EP1_OUT
		movwf	BD1ADRL_OUT
		movlw	ADR_H_EP1_OUT
		movwf	BD1ADRH_OUT
		movlw	b'10001000'		;  UOWN | DTSEN
		movwf	BD1STAT_OUT
			;Nastavenie ovladacich registrov vysielania z endpointu 1

		movlw	ADR_L_EP1_IN
		movwf	BD1ADRL_IN
		movlw	ADR_H_EP1_IN
		movwf	BD1ADRH_IN
		movlw	b'01001000'		;  DTS		POVODNE BOLO TOTO !!!
		;movlw	b'10001000'		;  UOWN | DTSEN
		movwf	BD1STAT_IN
		banksel	Pocet_Byte_EP0_IN
	return



;***********************************************************************************************************
;****************************************** PODPROGRAMY USB ************************************************
;********************************* PRE PRACOVNY ENDPOINT 1 IN/OUT ******************************************
;***********************************************************************************************************



	;Na vstup podprogramu sa pise hodnota do RAM.
	;Adresa RAM sa pise do premennej Adresa_USB_RAM. 0 je prvy bajt. Cize 0 az 63 bajtov = 64 bajtov
Zapis_na_adresu_USB_RAM
		banksel	Adresa_USB_RAM
		movwf	Hodnota_do_USB_RAM
		movlw	ADR_H_EP1_IN
		movwf	FSR0H
		movlw	ADR_L_EP1_IN
		banksel	Adresa_USB_RAM
		addwf	Adresa_USB_RAM,w
		movwf	FSR0L
		movf	Hodnota_do_USB_RAM,w
		movwf	INDF0
		banksel	PORTA
	return



	;Na vstup podprogramu sa pise adresa RAM.
Citanie_adresy_RAM_USB
		banksel	Adresa_USB_RAM
		movwf	Adresa_USB_RAM
		movlw	ADR_H_EP1_OUT
		movwf	FSR0H
		movlw	ADR_L_EP1_OUT
		banksel	Adresa_USB_RAM
		addwf	Adresa_USB_RAM,w
		movwf	FSR0L
		movf	INDF0,w
		banksel	PORTA
	return



Vymazanie_adresy_RAM_USB_OUT
		banksel	Adresa_USB_RAM
		movwf	Adresa_USB_RAM
		movlw	ADR_H_EP1_OUT
		movwf	FSR0H
		movlw	ADR_L_EP1_OUT
		banksel	Adresa_USB_RAM
		addwf	Adresa_USB_RAM,w
		movwf	FSR0L
		clrf	INDF0
		banksel	PORTA
	return




Skopiruj_RAM_USB_OUT_DO_USB_IN
			movlw	B_CNT_EP1_IN
			movwf	count1
			movlw	ADR_H_EP1_OUT
			movwf	FSR0H
			movlw	ADR_L_EP1_OUT
			movwf	FSR0L
			movlw	ADR_H_EP1_IN
			movwf	FSR1H
			movlw	ADR_L_EP1_IN
			movwf	FSR1L
		opakuj_kopirovanie_USB_RAM
			movf	INDF0,w
			movwf	INDF1
			incf	FSR0L,f
			incf	FSR1L,f
		decfsz	count1
		goto	opakuj_kopirovanie_USB_RAM
	return




Zapnutie_endpoinu_1_OUT
		btfsc	BD1STAT_OUT,7		;ak UOWN_OUT==1 (SIE vlastni BDT-out), vyskoc z podprogramu
			return	
		movlw	B_CNT_EP1_OUT
		movwf	BD1CNT_OUT
		;*****Logika prijmu dat - raz DAT1, raz DAT0*******
			;if (DTS==1) -> DTS=0
		btfss	BD1STAT_OUT,6
		goto	preskoc_prijem_EP1_ako_DAT_0
			movlw	b'10001000'		;UOWN | DTSEN
			movwf	BD1STAT_OUT
		goto	preskoc_prijem_EP1_ako_DAT_1
		preskoc_prijem_EP1_ako_DAT_0	
	;else
			;if (DTS==0) -> DTS=1
			movlw	b'11001000'		;UOWN | DTS | DTSEN
			movwf	BD1STAT_OUT
		preskoc_prijem_EP1_ako_DAT_1
	return




Zapnutie_endpoinu_1_IN
		banksel	BD1STAT_IN
		btfsc	BD1STAT_IN,7		;ak UOWN_IN==1 (SIE vlastni BDT-in), vyskoc z podprogramu
			return	
		movlw	B_CNT_EP1_IN
		movwf	BD1CNT_IN
		;*****Logika vysielania dat - raz DAT1, raz DAT0*******
			;if (DTS==1) -> DTS=0
		btfss	BD1STAT_IN,6
		goto	preskoc_vysielanie_EP1_ako_DAT_0
			movlw	b'10001000'		;UOWN | DTSEN
			movwf	BD1STAT_IN
		goto	preskoc_vysielanie_EP1_ako_DAT_1
		preskoc_vysielanie_EP1_ako_DAT_0	
	;else
			;if (DTS==0) -> DTS=1
			movlw	b'11001000'		;UOWN | DTS | DTSEN
			movwf	BD1STAT_IN
		preskoc_vysielanie_EP1_ako_DAT_1
	return




	;Prijem dat z USB do RAM cez endpoint 1 (OUT)
Prijem_dat_z_USB
		;--------------------- ROZNE PODMIENKY, KEDY NASTAL PRIJEM Z PC DO ENDPOINTU 1: -------------------
		bcf		Prisli_data_USB
			;ak je USB uz nakonfigurovane,...
		movlw	NAKONFIGUROVANE
		banksel	Stav_zariadenia
		subwf	Stav_zariadenia,w
		banksel	PORTA
		btfss	STATUS,Z
		return
			;ak nastala aktivita na endpointe 1,....
		call	Nacitanie_USB_STATUS_registra
		movlw	Endpoint_1
		subwf	Naposledy_aktivny_endpoint,w
		btfss	STATUS,Z
		return
			;ak posledny smer prenosu bol OUT,.....
		movlw	OUT
		subwf	Posledny_smer_prenosu,w
		btfss	STATUS,Z
		return
			;ak je pocet prijatych bajtov nenulovy,....
		banksel	BD1CNT_OUT
		movf	BD1CNT_OUT,w
		banksel	PORTA
		btfsc	STATUS,Z
		return
			;ak endpoint 1 OUT nie je vo vlastnictve jednotky SIE:
		banksel	BD1STAT_OUT
		btfsc	BD1STAT_OUT,7
		return
			;inicializuj endpoint 1 OUT na prijem dat z PC
		call	Zapnutie_endpoinu_1_OUT
		banksel	PORTA
			;Povolenie do hlavneho programu, ze prisli data.
		bsf		Prisli_data_USB
	return




;*******************************************************************************************
;*********************************** Hardwarove SPI ****************************************
;*******************************************************************************************



Pauza_SPI
		movlw	.10
		call	cakaj_x
	return




Command_SPI
		movwf	SPI_write_register
		clrf	SPI_Status_register
		movlw	.8
		movwf	SPI_bitcnt
		opakuj_SPI_command
				;Vysielanie Command Word
			bcf		STATUS,C
			rlf		SPI_write_register,f
			btfsc	STATUS,C
			bsf		MOSI
			btfss	STATUS,C
			bcf		MOSI
			call	Pauza_SPI
				;Prijem status registra pocas vysielania Command Word
			bsf		SCK
			call	Pauza_SPI
			btfsc	MISO
			bsf		STATUS,C
			btfss	MISO
			bcf		STATUS,C	
			rlf		SPI_Status_register,f
			bcf		SCK
		decfsz	SPI_bitcnt
		goto	opakuj_SPI_command
		movf	SPI_Status_register,w
	return




Data_read_SPI
			;Prijem dat
		clrf	SPI_read_register
		movlw	.8
		movwf	SPI_bitcnt
		opakuj_SPI_data_RX	
			call	Pauza_SPI
			bsf		SCK
			call	Pauza_SPI
			btfsc	MISO
			bsf		STATUS,C
			btfss	MISO
			bcf		STATUS,C	
			rlf		SPI_read_register,f
			bcf		SCK
		decfsz	SPI_bitcnt
		goto	opakuj_SPI_data_RX
		movf	SPI_read_register,w
	return



Data_write_SPI
		movwf	SPI_write_register
		movlw	.8
		movwf	SPI_bitcnt
		opakuj_SPI_write
				;Vysielanie Command Word
			bcf		STATUS,C
			rlf		SPI_write_register,f
			btfsc	STATUS,C
			bsf		MOSI
			btfss	STATUS,C
			bcf		MOSI
			call	Pauza_SPI
			bsf		SCK
			call	Pauza_SPI
			bcf		SCK
		decfsz	SPI_bitcnt
		goto	opakuj_SPI_write
	return


;================================================== SPI commands ===========================================================



;oooo
	;Zapis variabilneho poctu bajtov naraz.
Write_register_RFM75
			;Nacitaj adresu
		movwf	SPI_Adresa
		bcf		CE
			;Adresa PIC RAM, kam sa uklada obsah datovych byte
		movlw	ADR_H
		movwf	FSR0H
		movlw	ADR_L
		movwf	FSR0L
			;Zadaj pocet datovych byte k citaniu
		movf	Pocet_byte_RFM75,w
		movwf	SPI_bytcnt
			;Zapni komunikaciu SPI s modulom
		bsf		CSN
		call	Pauza_SPI
		bcf		CSN			
		call	Pauza_SPI
			;Odosli adresu, do ktorej sa bude zapisovat. (Podprogram vracia do W reg. obsah STATUS registra modulu.)
		movf	SPI_Adresa,w
		andlw	b'00011111'
		iorlw	b'00100000'
		call	Command_SPI
			;Nacitaj data do prednastaveneho poctu byte. Podprogram vracia obsah nacitaneho byte do W registra.
		opakuj_zapis_bajtov
			movf	INDF0,w
			call	Data_write_SPI
			incf	FSR0L,f
		decfsz	SPI_bytcnt
		goto	opakuj_zapis_bajtov
			;Vypni komunikaciu SPI s modulom
		call	Pauza_SPI
		bsf		CSN			
		call	Pauza_SPI
	return









	;Citanie variabilneho poctu bajtov naraz.
Read_register_RFM75
			;Nacitaj adresu
		movwf	SPI_Adresa
			;Adresa PIC RAM, kam sa uklada obsah datovych byte
		movlw	ADR_H_Rx
		movwf	FSR0H
		movlw	ADR_L_Rx
		movwf	FSR0L
			;Zadaj pocet datovych byte k citaniu
		movf	Pocet_byte_RFM75,w
		movwf	SPI_bytcnt
			;Zapni komunikaciu SPI s modulom
		bsf		CSN
		call	Pauza_SPI
		bcf		CSN			
		call	Pauza_SPI
			;Odosli adresu, z ktorej sa bude citat. (Podprogram vracia do W reg. obsah STATUS registra modulu.)
		movf	SPI_Adresa,w
		andlw	b'00011111'
		call	Command_SPI
			;Nacitaj data do prednastaveneho poctu byte. Podprogram vracia obsah nacitaneho byte do W registra.
		opakuj_citanie_bajtov
			call	Data_read_SPI
			movwf	INDF0
			incf	FSR0L,f
		decfsz	SPI_bytcnt
		goto	opakuj_citanie_bajtov
			;Vypni komunikaciu SPI s modulom
		call	Pauza_SPI
		bsf		CSN			
		call	Pauza_SPI
	return













Write_register_1_Byte_RFM75
	;Vloz z W reg. hodnotu nastaveni CONFIG registra modulu RFM75
		movwf	TMP_1_SPI
			;Zapni komunikaciu SPI s modulom
		bsf		CSN
		call	Pauza_SPI
		bcf		CSN			
		call	Pauza_SPI
			;Odosli adresu, do ktorej sa bude zapisovat. (Podprogram vracia do W reg. obsah STATUS registra modulu.)
		movf	SPI_Adresa,w
		andlw	b'00011111'
		iorlw	b'00100000'
		call	Command_SPI
		movf	TMP_1_SPI,w
		call	Data_write_SPI
			;Vypni komunikaciu SPI s modulom
		call	Pauza_SPI
		bsf		CSN			
		call	Pauza_SPI
	return


Read_register_1_Byte_RFM75
		movwf	SPI_Adresa
			;Zapni komunikaciu SPI s modulom
		bsf		CSN
		call	Pauza_SPI
		bcf		CSN			
		call	Pauza_SPI
			;Odosli adresu, do ktorej sa bude zapisovat. (Podprogram vracia do W reg. obsah STATUS registra modulu.)
		movf	SPI_Adresa,w
		andlw	b'00011111'
		call	Command_SPI
		call	Data_read_SPI
		movwf	TMP_1_SPI
			;Vypni komunikaciu SPI s modulom
		call	Pauza_SPI
		bsf		CSN			
		call	Pauza_SPI
		movf	TMP_1_SPI,w
	return




R_RX_PAYLOAD
			;Adresa PIC RAM, kam sa uklada obsah datovych byte
		movlw	ADR_H_Rx
		movwf	FSR0H
		movlw	ADR_L_Rx
		movwf	FSR0L
			;Zadaj pocet datovych byte k citaniu
		movf	Pocet_byte_RFM75,w
		movwf	SPI_bytcnt
			;Zapni komunikaciu SPI s modulom
		bsf		CSN
		call	Pauza_SPI
		bcf		CSN			
		call	Pauza_SPI
			;Odosli adresu, z ktorej sa bude citat. (Podprogram vracia do W reg. obsah STATUS registra modulu.)
		movlw	b'01100001'
		call	Command_SPI
			;Nacitaj data do prednastaveneho poctu byte. Podprogram vracia obsah nacitaneho byte do W registra.
		opakuj_citanie_RX_dat
			call	Data_read_SPI
			movwf	INDF0
			incf	FSR0L,f
		decfsz	SPI_bytcnt
		goto	opakuj_citanie_RX_dat
			;Vypni komunikaciu SPI s modulom
		call	Pauza_SPI
		bsf		CSN			
		call	Pauza_SPI
	return







W_TX_PAYLOAD
			;Zadaj z W registra pocet byte k vysielaniu
		movwf	SPI_bytcnt
		bcf		CE
			;Adresa PIC RAM, kam sa uklada obsah datovych byte
		movlw	ADR_H_Tx
		movwf	FSR0H
		movlw	ADR_L_Tx
		movwf	FSR0L
			;Zapni komunikaciu SPI s modulom
		bsf		CSN
		call	Pauza_SPI
		bcf		CSN			
		call	Pauza_SPI
			;Odosli adresu, z ktorej sa bude citat. (Podprogram vracia do W reg. obsah STATUS registra modulu.)
		movlw	b'10100000'
		call	Command_SPI
			;Nacitaj data do prednastaveneho poctu byte. Podprogram vracia obsah nacitaneho byte do W registra.
		opakuj_zapis_TX_dat
			movf	INDF0,w
			call	Data_write_SPI
			incf	FSR0L,f
		decfsz	SPI_bytcnt
		goto	opakuj_zapis_TX_dat
			;Vypni komunikaciu SPI s modulom
		call	Pauza_SPI
		bsf		CSN			
		call	Pauza_SPI
	return





R_RX_PAYLOAD_1_byte
		clrf	TMP_1_SPI
			;Zapni komunikaciu SPI s modulom
		bsf		CSN
		call	Pauza_SPI
		bcf		CSN			
		call	Pauza_SPI
			;Odosli adresu, z ktorej sa bude citat. (Podprogram vracia do W reg. obsah STATUS registra modulu.)
		movlw	b'01100001'
		call	Command_SPI
		call	Data_read_SPI
		movwf	TMP_1_SPI
		call	Pauza_SPI
		bsf		CSN			
		call	Pauza_SPI
		movf	TMP_1_SPI,w
	return




W_TX_PAYLOAD_1_byte_RFM75
			;Vloz z W reg. hodnotu 1 byte paketu
		movwf	TMP_1_SPI
			;Zapni komunikaciu SPI s modulom
		bsf		CSN
		call	Pauza_SPI
		bcf		CSN			
		call	Pauza_SPI
			;Odosli adresu, do ktorej sa bude zapisovat. (Podprogram vracia do W reg. obsah STATUS registra modulu.)
		movlw	b'10100000'
		call	Command_SPI
		movf	TMP_1_SPI,w
		call	Data_write_SPI
			;Vypni komunikaciu SPI s modulom
		call	Pauza_SPI
		bsf		CSN			
		call	Pauza_SPI
	return




FLUSH_TX_RFM75
		bsf		CSN
		call	Pauza_SPI
		bcf		CSN			
		call	Pauza_SPI
		movlw	b'11100001'
		call	Command_SPI
		call	Pauza_SPI
		bsf		CSN			
		call	Pauza_SPI
	return




FLUSH_RX_RFM75
		bsf		CSN
		call	Pauza_SPI
		bcf		CSN			
		call	Pauza_SPI
		movlw	b'11100010'
		call	Command_SPI
		call	Pauza_SPI
		bsf		CSN			
		call	Pauza_SPI
	return



REUSE_TX_PL_RFM75
		bsf		CSN
		call	Pauza_SPI
		bcf		CSN			
		call	Pauza_SPI
		movlw	b'11100011'
		call	Command_SPI
		call	Pauza_SPI
		bsf		CSN			
		call	Pauza_SPI
	return



	;Aktivacia registrov DYNPD (0x1C) a FEATURE (0x1D), lebo by sa inak nedalo do nich zapisovat.
	;Tiez aktivuje funkcie R_RX_PL_WID, W_ACK_PAYLOAD, W_TX_PAYLOAD_NOACK.
Activate_Feature_RFM75
		bsf		CSN
		call	Pauza_SPI
		bcf		CSN			
		call	Pauza_SPI
		movlw	b'01010000'
		call	Command_SPI
		movlw	0x73
		call	Command_SPI
		call	Pauza_SPI
		bsf		CSN			
		call	Pauza_SPI
	return



	;Prepnutie banky z 0 na 1 a opacne.
Activate_Banksel_RFM75
		bsf		CSN
		call	Pauza_SPI
		bcf		CSN			
		call	Pauza_SPI
		movlw	b'01010000'
		call	Command_SPI
		movlw	0x53
		call	Command_SPI
		call	Pauza_SPI
		bsf		CSN			
		call	Pauza_SPI
	return



	;Precitanie poctu prijatych byte v pakete v pripade dynamickej dlzky paketu. Je nutna aktivacia pomocou Activate_Feature_RFM75.
R_RX_PL_WID_RFM75
		bsf		CSN
		call	Pauza_SPI
		bcf		CSN			
		call	Pauza_SPI
		movlw	b'01100000'
		call	Command_SPI
		call	Data_read_SPI
		movwf	TMP_1_SPI
		call	Pauza_SPI
		bsf		CSN			
		call	Pauza_SPI
		movf	TMP_1_SPI,w
	return




W_ACK_PAYLOAD_1_byte_RFM75
			;Vloz z W reg. hodnotu 1 byte paketu
		movwf	TMP_1_SPI
			;Zapni komunikaciu SPI s modulom
		bsf		CSN
		call	Pauza_SPI
		bcf		CSN			
		call	Pauza_SPI
			;Odosli adresu, do ktorej sa bude zapisovat. (Podprogram vracia do W reg. obsah STATUS registra modulu.)
		movlw	b'10101000'
		call	Command_SPI
		movf	TMP_1_SPI,w
		call	Data_write_SPI
			;Vypni komunikaciu SPI s modulom
		call	Pauza_SPI
		bsf		CSN			
		call	Pauza_SPI
	return



W_TX_PAYLOAD_NOACK_1_byte_RFM75
			;Vloz z W reg. hodnotu 1 byte paketu
		movwf	TMP_1_SPI
			;Zapni komunikaciu SPI s modulom
		bsf		CSN
		call	Pauza_SPI
		bcf		CSN			
		call	Pauza_SPI
			;Odosli adresu, do ktorej sa bude zapisovat. (Podprogram vracia do W reg. obsah STATUS registra modulu.)
		movlw	b'10110000'
		call	Command_SPI
		movf	TMP_1_SPI,w
		call	Data_write_SPI
			;Vypni komunikaciu SPI s modulom
		call	Pauza_SPI
		bsf		CSN			
		call	Pauza_SPI
	return




NOP_RFM75
		bsf		CSN
		call	Pauza_SPI
		bcf		CSN			
		call	Pauza_SPI
		movlw	b'11111111'
		call	Command_SPI
		call	Pauza_SPI
		bsf		CSN			
		call	Pauza_SPI
	return





;=================================================================================================================


OBSERVE_TX_RFM75
		movlw	OBSERVE_TX
		call	Read_register_1_Byte_RFM75
	return



RX_PW_P0_RFM75
		movlw	RX_PW_P0
		call	Read_register_1_Byte_RFM75
	return


RESET_RX_DR_RFM75
			;Status register (Vynulovanie stavoveho bitu o prijatom pakete)
		movlw	STATUS_RFM75
		movwf	SPI_Adresa
		movlw	b'01000000'
		call	Write_register_1_Byte_RFM75
	return




RESET_TX_DS_RFM75
			;Status register (Vynulovanie stavoveho bitu o odoslanom pakete)
		movlw	STATUS_RFM75
		movwf	SPI_Adresa
		movlw	b'00100000'
		call	Write_register_1_Byte_RFM75
	return



RESET_MAX_RT_RFM75
			;Status register (Vynulovanie stavoveho bitu o dosiahnuti nastaveneho poctu opakovani vysielania)
		movlw	STATUS_RFM75
		movwf	SPI_Adresa
		movlw	b'00010000'
		call	Write_register_1_Byte_RFM75
	return









POWER_UP_RFM75
		movlw	b'00000010'
		call	CONFIG_bit_enable
		bsf		CE				;Chip Enable
		call	Pauza_200us
	return




POWER_DOWN_RFM75
		bcf		CE				;Chip Disable
		call	Pauza_200us
		movlw	b'00000010'	
		call	CONFIG_bit_disable
	return



PRX_RFM75
		movlw	b'00000001'
		call	CONFIG_bit_enable
	return




PTX_RFM75
		movlw	b'00000001'	
		call	CONFIG_bit_disable
	return






CONFIG_bit_enable
		movwf	TMP_MASKA_SPI
			;Zapni komunikaciu SPI s modulom
		bsf		CSN
		call	Pauza_SPI
		bcf		CSN			
		call	Pauza_SPI
			;Odosli adresu, do ktorej sa bude zapisovat.
		movlw	CONFIG
		call	Adresa_RFM75
		andlw	b'00011111'		;Maska adresy (5 bitov)
		iorlw	b'00100000'		;Kod pre zapis na adresu (bit 5 = 1)
		call	Command_SPI		;Odoslanie adresy do modulu RFM75. Sucasne modul posiela data STATUS registra.
			;Zapnutie bitu bez vplyvu na stav ostatnych.
		movf	CONFIG_RAM_PIC,w
		iorwf	TMP_MASKA_SPI,w
		call	Data_write_SPI		;Odoslanie hodnoty na adrese do modulu RFM75. 
			;Vypni komunikaciu SPI s modulom
		call	Pauza_SPI
		bsf		CSN			
		call	Pauza_SPI
	return




CONFIG_bit_disable
			;Maska pre zapnutie jedneho bitu
		movwf	TMP_MASKA_SPI
		comf	TMP_MASKA_SPI,f
			;Zapni komunikaciu SPI s modulom
		bsf		CSN
		call	Pauza_SPI
		bcf		CSN			
		call	Pauza_SPI
			;Odosli adresu, do ktorej sa bude zapisovat.
		movlw	CONFIG
		call	Adresa_RFM75
		andlw	b'00011111'		;Maska adresy (5 bitov)
		iorlw	b'00100000'		;Kod pre zapis na adresu (bit 5 = 1)
		call	Command_SPI		;Odoslanie adresy do modulu RFM75. Sucasne modul posiela data STATUS registra.
			;Zapnutie bitu bez vplyvu na stav ostatnych.
		movf	CONFIG_RAM_PIC,w
		andwf	TMP_MASKA_SPI,w
		call	Data_write_SPI		;Odoslanie hodnoty na adrese do modulu RFM75. 
			;Vypni komunikaciu SPI s modulom
		call	Pauza_SPI
		bsf		CSN			
		call	Pauza_SPI
	return






Nastavenie_frekvencie
		andlw	b'01111111'		;Iba 7 bitov sa pouziva
		movwf	TMP_1_SPI
			;Zapni komunikaciu SPI s modulom
		bsf		CSN
		call	Pauza_SPI
		bcf		CSN			
		call	Pauza_SPI
			;Odosli adresu, do ktorej sa bude zapisovat. (Podprogram vracia do W reg. obsah STATUS registra modulu.)
		movlw	RF_CH
		iorlw	b'00100000'			;Kod pre zapis na adresu
		call	Command_SPI
		movf	TMP_1_SPI,w
		call	Data_write_SPI
			;Vypni komunikaciu SPI s modulom
		call	Pauza_SPI
		bsf		CSN			
		call	Pauza_SPI
	return








Precitanie_frekvencie
			;Zapni komunikaciu SPI s modulom
		bsf		CSN
		call	Pauza_SPI
		bcf		CSN			
		call	Pauza_SPI
			;Odosli adresu, do ktorej sa bude zapisovat. (Podprogram vracia do W reg. obsah STATUS registra modulu.)
		movlw	RF_CH
		andlw	b'00011111'			
		call	Command_SPI
		call	Data_read_SPI
		movwf	TMP_1_SPI
			;Vypni komunikaciu SPI s modulom
		call	Pauza_SPI
		bsf		CSN			
		call	Pauza_SPI
		movf	TMP_1_SPI,w
	return










INIT_RFM75
			;23 adries, na ktore sa ukladaju data nastaveni modulu RFM75
		movlw	.23
		movwf	cnt_RFM75
		clrf	SPI_bytcnt
		clrf	SPI_addrcnt

		;Aktivacia registrov DYNPD (0x1C) a FEATURE (0x1D), lebo by sa inak nedalo do nich zapisovat.
		call	Activate_Feature_RFM75

		dalsia_adresa

				;Zapni komunikaciu SPI s modulom
			bsf		CSN
			call	Pauza_SPI
			bcf		CSN			
			call	Pauza_SPI
	
				;Odosli adresu, do ktorej sa bude zapisovat. (Podprogram vracia do W reg. obsah STATUS registra modulu.)
			movf	SPI_addrcnt,w	;Napocitavanie adries = Posun po adresach
			call	Adresa_RFM75	;Tabulka adries
			movwf	TMP_1_SPI
			andlw	b'00011111'		;Maska adresy (5 bitov)
			iorlw	b'00100000'		;Kod pre zapis na adresu (bit 5 = 1)
			call	Command_SPI		;Odoslanie adresy do modulu RFM75. Sucasne modul posiela data STATUS registra.
	
			movf	SPI_datacnt,w		;Napocitavanie hodnot pre jednotlive adresy.
			call	Default_data_RFM75	;Tabulka hodnot
			call	Data_write_SPI		;Odoslanie hodnoty na adrese do modulu RFM75. 

				;Posun na dalsiu adresu a jej hodnotu v tabulkach dt.
			incf	SPI_datacnt,f
			incf	SPI_addrcnt,f
	
				;Na adresy ktore obsahuju 5 byte, sa dodatocne ukladaju este dalsie 4 byte dat.
			movlw	.4
			movwf	SPI_bytcnt
			movf	TMP_1_SPI,w
			sublw	0x10
			btfsc	STATUS,Z
			goto	vykonaj_5byte_dat
			movf	TMP_1_SPI,w
			sublw	0x0A
			btfsc	STATUS,Z
			goto	vykonaj_5byte_dat
			movf	TMP_1_SPI,w
			sublw	0x0B
			btfsc	STATUS,Z
			goto	vykonaj_5byte_dat
			goto	preskoc_5byte_dat
			vykonaj_5byte_dat
				movf	SPI_datacnt,w
				call	Default_data_RFM75
				call	Data_write_SPI
				incf	SPI_datacnt,f		;Posun na dalsiu hodnotu na konkretnej adrese v tabulke dt.
			decfsz	SPI_bytcnt
			goto	vykonaj_5byte_dat
			preskoc_5byte_dat
				;Vypni komunikaciu SPI s modulom
			call	Pauza_SPI
			bsf		CSN			
			call	Pauza_SPI
			call	Pauza_1us
		decfsz	cnt_RFM75,f
		goto	dalsia_adresa


			;Nacitanie defaultneho nastavenia registra CONFIG do internej premennej
		movlw	CONFIG
		call	Default_data_RFM75
		movwf	CONFIG_RAM_PIC

	return






Odvysielanie_spravy_RFM75
			call	PTX_RFM75		;Zapnutie TX			
			bsf		CE				;Chip Enable
				;Vysielacia slucka. Opusti sa bud dorucenim ACK paketu, alebo po prekroceni poctu pokusov opakovania.
			opakuj_cakanie_vysielania
					;Nacitanie STATUS_RFM75 registra.
				call	NOP_RFM75
					;test maximalneho poctu opakovani vysielania nedoruceneho paketu. 
				movf	SPI_Status_register,w
				andlw	b'00010000'
				sublw	b'00010000'
				btfsc	STATUS,Z
				goto	opusti_cakanie_vysielania
					;test odoslania paketu, pripadne dorucenia ACK od adresata (v pripade modu opakovania)
				movf	SPI_Status_register,w
				andlw	b'00100000'
				sublw	b'00100000'
			btfss	STATUS,Z
			goto	opakuj_cakanie_vysielania
			opusti_cakanie_vysielania


				;Udaj o pocte nedorucenych paketov do PC
				;Adresa USB RAM IN
			movlw	ADR_H_EP1_IN
			movwf	FSR1H
			movlw	ADR_L_EP1_IN
			addlw	.32
			movwf	FSR1L
			call	OBSERVE_TX_RFM75
			movwf	INDF1
				;Odoslanie dat do PC
			call	Zapnutie_endpoinu_1_IN


				;Prepnutie na prijem.
			bcf		CE				;Chip Disable
			call	PRX_RFM75		;Prepnutie na RX
				;Vynulovanie statusovych bitov o prekroceni poctu pokusov a doruceni ACK paketu.
			call	RESET_TX_DS_RFM75
			call	RESET_MAX_RT_RFM75
			bsf		CE				;Chip Enable
			call	Pauza_200us
				;Zmazanie TX FIFO (preistotu)
			call	FLUSH_TX_RFM75
	return
















;**************************************************************************************************
;************************************ OBSLUHA PRERUSENIA ******************************************
;**************************************************************************************************


prerusenie	
		clrwdt
		banksel	INTCON
		bcf		INTCON,GIE
		banksel	PIR2
			;Prerusenia z USB (enumeracia + data)
		btfss	PIR2,USBIF
		goto	preskoc_USB
				;Prijem dat z PC do RAM PIC cez USB endpoint 1
			call	Prijem_dat_z_USB
				;Enumeracia a prihlasenie USB + spracovavanie niektorych preruseni z USB
			call	Prerusenia_USB
		preskoc_USB

			;Prerusenie od spadovej hrany na pine z IRQ modulu RFM75
		banksel	IOCAF
		btfss	IOCAF,4
		goto	preskoc_RFM75_RX
			bcf		IOCAF,4
			banksel	INTCON
			bcf		INTCON,IOCIF
			banksel	Adresa_USB_RAM


;call	Clear_linear_RAM


				;Kod pre PC, ze sa jedna o prijate data z modulu RFM75
			movlw	.0
			movwf	Adresa_USB_RAM
			movlw	DATA_DO_PC
			call	Zapis_na_adresu_USB_RAM
				;Informacia pre PC, kolko byte v pakete prislo
			movlw	.1
			movwf	Adresa_USB_RAM
				;Precitanie poctu prijatych byte v pakete v pripade dynamickej dlzky paketu
			call	R_RX_PL_WID_RFM75	
			movwf	Pocet_byte_RFM75
			call	Zapis_na_adresu_USB_RAM
				;Prijem variabilnej dlzky paketu
			call	R_RX_PAYLOAD
				;Skopirovanie obsahu paketu z adries na to urcenych, na adresy pre USB prenos
				;Nastastavenie pociatku adries
			movlw	ADR_H_Rx
			movwf	FSR0H
			movlw	ADR_L_Rx
			movwf	FSR0L
			movlw	ADR_H_EP1_IN
			movwf	FSR1H
			movlw	ADR_L_EP1_IN
			addlw	.4+.5				;offset od adresy 
			movwf	FSR1L
;ooo - od adresy .4 do .4+.4 treba poslat este aktualnu adresu, s ktorou sa pracuje
				;Samotne kopirovanie bajtov
			opakuj_citanie_paketu_RFM75
				movf	INDF0,w
				movwf	INDF1
				incf	FSR0L,f
				incf	FSR1L,f
				clrf	INDF1
			decfsz	Pocet_byte_RFM75,f
			goto	opakuj_citanie_paketu_RFM75
				;Odoslanie USB dat do PC
			call	Zapnutie_endpoinu_1_IN
			call	Pauza_200us
				;Vynulovanie stavoveho bitu o prijatom pakete
			call	RESET_RX_DR_RFM75	
				;Zmazanie RX FIFO (preistotu)
			call	FLUSH_RX_RFM75


		preskoc_RFM75_RX
		


		banksel	INTCON
		bsf		INTCON,GIE
		banksel	PORTA
	retfie


;**************************************************************************************************
;************************************* HLAVNY PROGRAM ******************************************
;**************************************************************************************************


START
	bcf		INTCON,GIE
	call	Nastavenie_PIC
	call	vycistenie_GPR_banky_0
	call	Clear_linear_RAM
	call	Inicializacia_USB
	call	Zapnutie_USB_modulu
	call	Aktivacia_preruseni
	call	vycistenie_RAM_EP1_OUT
	call	vycistenie_RAM_EP1_IN

	
	bcf		INTCON,GIE

	call	INIT_RFM75

	bsf		CE
	call	Pauza_200us




opakuj

	bcf		INTCON,GIE

		;Informacia o prichode dat do USB RAM_IN 
	btfss	Prisli_data_USB
	goto	preskoc_citanie_RAM_USB
	bcf		Prisli_data_USB

	;-------------------------Ovladacie cisla z PC programu posielam do prveho cisla 64 bytoveho paketu EP_1_OUT.------------------------

			;Nacitanie ovladacieho cisla z PC do premennej TMP. 
		movlw	.0
		movwf	Adresa_USB_RAM
		movlw	.0	; adresa RAM
		call	Citanie_adresy_RAM_USB
		movwf	TMP



	;---------------------------------------- Spracovanie kodu poziadavky -------------------------------------------



			;Kod vyzvy k inicializacii nastavenii modulu RFM75.
		movlw	Init_RFM75
		subwf	TMP,w
		btfss	STATUS,Z
		goto	preskoc_frekvenciu
			bcf		CE				;Chip Disable
				;Adresa pamate RAM USB, do ktorej sa z PC uklada cislo kanalu 2400 + X MHz
			movlw	.3
			movwf	Adresa_USB_RAM
			call	Citanie_adresy_RAM_USB
				;Zapis dat na adresu zmeny frekvencie
			call	Nastavenie_frekvencie	
				;Odoslanie hodnoty frekvencie z registra modulu RFM75 do PC. (Tj. spetna kontrola, ci k zmene doslo.)
			movlw	.0
			movwf	Adresa_USB_RAM
				;Kod oznamujuci PC programu, ze inicializacia prebehla (aby PC zastavil casovac Timer2)
			movlw	Init_RFM75					
			call	Zapis_na_adresu_USB_RAM
				;Adresa USB paketu, na ktorej posielam do PC hodnotu frekvencie
			movlw	.2						
			movwf	Adresa_USB_RAM
			call	Precitanie_frekvencie
			call	Zapis_na_adresu_USB_RAM
				;Odoslanie dat do PC
			call	Zapnutie_endpoinu_1_IN
			bsf		CE				;Chip Enable
			call	Pauza_200us						
		preskoc_frekvenciu






;oooo
			;Kod z PC pozadujuci zmenu adresy  modulu RFM75.
		movlw	NastavenieAdresyRFM75
		subwf	TMP,w
		btfss	STATUS,Z
		goto	preskoc_adresu
			bcf		CE				;Chip Disable
			clrf	Pocet_byte_RFM75
				;Adresa, na ktorej PC posiela pocet byte adresy pre modul RFM75
			movlw	.1
			movwf	Adresa_USB_RAM
			call	Citanie_adresy_RAM_USB
			movwf	Pocet_byte_RFM75
			movwf	TMP_1_USB
				;Adresa v USB pakete, od ktorej PC posiela cisla adresy. (Pocet znakov je v druhom bajte.)
			movlw	ADR_H_EP1_OUT
			movwf	FSR0H
			movlw	ADR_L_EP1_OUT
			addlw	.4
			movwf	FSR0L
				;Adresa pamati, z ktorej sa prenasaju data do registrov adresy modulu RFM75.
			movlw	ADR_H
			movwf	FSR1H
			movlw	ADR_L
			movwf	FSR1L
				;Kopirovanie dat z USB RAM OUT do RAM, z ktorej sa prenasaju do registrov adresy modulu RFM75
			movf	Pocet_byte_RFM75,w
			movwf	count1
			opakuj_kopirovanie_pre_TX
				movf	INDF0,w
				movwf	INDF1
				incf	FSR0L,f
				incf	FSR1L,f
			decfsz	count1,f
			goto	opakuj_kopirovanie_pre_TX
			movf	Pocet_byte_RFM75,w
				;Vykonaj vlozenie dat z PIC RAM do registra RX adresy modulu RFM75
			movlw	RX_ADDR_P0
			call	Write_register_RFM75	
				;Vykonaj vlozenie dat z PIC RAM do registra TX adresy modulu RFM75
			movlw	TX_ADDR
			call	Write_register_RFM75	
				;Nastavenie poctu platnych byte adresy do modulu RFM75
			movlw	SETUP_AW
			movwf	SPI_Adresa
			movlw	.2					;Dlzka adresy: 1 = 3byte, 2 = 4byte, 3 = 5byte
			subwf	Pocet_byte_RFM75,w
			call	Write_register_1_Byte_RFM75
			bsf		CE				;Chip Enable
		preskoc_adresu





			;Kod oznamujuci pisanie textu do okienka, ktory treba vysielat cez RFM75.
		movlw	DATA_Z_PC
		subwf	TMP,w
		btfss	STATUS,Z
		goto	preskoc_prijem_znaku
			clrf	Pocet_byte_RFM75
				;Adresa, na ktorej PC posiela pocet byte k vysielaniu modulom RFM75
			movlw	.1
			movwf	Adresa_USB_RAM
			call	Citanie_adresy_RAM_USB
			movwf	Pocet_byte_RFM75
				;V pripade, ze je pocet dat nulovy (prazdne okienko),
			btfsc	STATUS,Z
			incf	Pocet_byte_RFM75,f
				;Adresa v USB pakete, od ktorej PC posiela znaky k odoslaniu. (Pocet znakov je v druhom bajte.)
			movlw	ADR_H_EP1_OUT
			movwf	FSR0H
			movlw	ADR_L_EP1_OUT
			addlw	.4
			movwf	FSR0L
				;Adresa pamati, z ktorej sa prenasaju data do TX FIFO pamati modulu RFM75 k vysielaniu pri volani W_TX_PAYLOAD.
			movlw	ADR_H_Tx
			movwf	FSR1H
			movlw	ADR_L_Tx
			movwf	FSR1L
				;Kopirovanie dat z USB RAM OUT do RAM, z ktorej sa prenasaju do TX FIFO pamati modulu RFM75 k vysielaniu
			movf	Pocet_byte_RFM75,w
			movwf	count1
			opakuj_kopirovanie_adresy
				movf	INDF0,w
				movwf	INDF1
				incf	FSR0L,f
				incf	FSR1L,f
			decfsz	count1,f
			goto	opakuj_kopirovanie_adresy
			movf	Pocet_byte_RFM75,w
				;Vykonaj vlozenie dat z PIC RAM do TX FIFO pamati modulu RFM75
			call	W_TX_PAYLOAD	
			call	Odvysielanie_spravy_RFM75
		preskoc_prijem_znaku








			;Kod oznamujuci zmenu frekvencie.
		movlw	ZMENA_FREKVENCIE
		subwf	TMP,w
		btfss	STATUS,Z
		goto	preskoc_init
			bcf		CE				;Chip Disable
				;Adresa pamate RAM USB, do ktorej sa z PC uklada cislo kanalu 2400 + X MHz
			movlw	.3
			movwf	Adresa_USB_RAM
			call	Citanie_adresy_RAM_USB
				;Zapis dat na adresu zmeny frekvencie
			call	Nastavenie_frekvencie		
				;Odoslanie hodnoty frekvencie z registra modulu RFM75 do PC. (Tj. spetna kontrola, ci k zmene doslo.)
			movlw	.0
			movwf	Adresa_USB_RAM
				;Kod oznamujuci PC programu, ze sa jedna o udaj frekvencie z modulu RFM75
			movlw	ZMENA_FREKVENCIE					
			call	Zapis_na_adresu_USB_RAM
				;Adresa USB paketu, na ktorej posielam do PC hodnotu frekvencie
			movlw	.2						
			movwf	Adresa_USB_RAM
			call	Precitanie_frekvencie
			call	Zapis_na_adresu_USB_RAM
				;Odoslanie dat do PC
			call	Zapnutie_endpoinu_1_IN
			bsf		CE				;Chip Enable
			call	Pauza_200us						
		preskoc_init














			;Tlacitko 1
		movf	TMP,w
		sublw	0x01
		btfss	STATUS,Z
		goto	preskoc_obsluhu_tlacitka_1

				;Adresa pamati dat na pre vysielanie modulom RFM75
			movlw	ADR_H_Tx
			movwf	FSR1H
			movlw	ADR_L_Tx
			movwf	FSR1L
				;Vkladanie dat do RAM pre vysielanie modulom RFM75
			movlw	'A'
			movwf	INDF1
				incf	FSR1L,f
			movlw	'B'
			movwf	INDF1
				incf	FSR1L,f
			movlw	'C'
			movwf	INDF1
				incf	FSR1L,f
			movlw	'D'
			movwf	INDF1
				incf	FSR1L,f
			movlw	'E'
			movwf	INDF1
				;Stanovenie poctu byte, ktore sa realne prenesu z PIC RAM do TX FIFO pamati modulu RFM75
			movlw	.4
				;Vykonaj vlozenie dat z PIC RAM do TX FIFO pamati modulu RFM75
			call	W_TX_PAYLOAD	
					
				;Odvysielaj spravu vlozenu do TX FIFO pamati modulu RFM75
			call	Odvysielanie_spravy_RFM75
	
		preskoc_obsluhu_tlacitka_1






			;Obsluha tlacitka 2
		movf	TMP,w
		sublw	0x02
		btfss	STATUS,Z
		goto	preskoc_obsluhu_tlacitka_2
			bcf		CE	
				;Adresa USB RAM IN
			movlw	ADR_H_EP1_IN
			movwf	FSR1H
			movlw	ADR_L_EP1_IN
			addlw	0x08
			movwf	FSR1L
				;Zapni komunikaciu SPI s modulom
			bsf		CSN
			call	Pauza_SPI
			bcf		CSN			
			call	Pauza_SPI
				;Odosli adresu, z ktorej sa bude citat. (Podprogram vracia do W reg. obsah STATUS registra modulu.)
			movlw	0x1D
			call	Command_SPI

			call	Data_read_SPI
			movwf	INDF1
				;Vypni komunikaciu SPI s modulom
			call	Pauza_SPI
			bsf		CSN			
			call	Pauza_SPI
				;Odoslanie dat do PC
			call	Zapnutie_endpoinu_1_IN
		preskoc_obsluhu_tlacitka_2



			;Tlacitko vymazat v PC vynuluje i citanie poziadaviek ControlTransferov z pamati.
		movlw	.3
		subwf	TMP,w
		btfss	STATUS,Z
		goto	preskoc_RESET
			call	POWER_DOWN_RFM75
			call	Clear_linear_RAM
			reset
		preskoc_RESET



			;Obsluha tlacitka "Status"
		movf	TMP,w
		sublw	0x04
		btfss	STATUS,Z
		goto	preskoc_obsluhu_tlacitka_4
			
			call	NOP_RFM75

				;Adresa USB RAM IN
			movlw	ADR_H_EP1_IN
			movwf	FSR1H
			movlw	ADR_L_EP1_IN
			addlw	.32
			movwf	FSR1L
				
			movf	SPI_Status_register,w
			movwf	INDF1

				;Odoslanie dat do PC
			call	Zapnutie_endpoinu_1_IN

		preskoc_obsluhu_tlacitka_4

	



	preskoc_citanie_RAM_USB

	bsf		INTCON,GIE

	clrwdt

	goto	opakuj
END
