
#include "Premenne.h"
#include "Zdroje.h"
#include "Funkcie.h"



//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////// VLAKNO PROCESU RX USB (OUT) /////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Procedura vlakna
DWORD WINAPI ThreadProc(LPVOID lpParam) 
{
	//Vytvorenie udalosti sledovanej vo vlakne
	ev = CreateEvent(NULL, FALSE, FALSE /*inital state f=nonsignaled*/, NULL);
	memset(&osRead, 0, sizeof(osRead));
	osRead.hEvent = ev;
    if(osRead.hEvent==NULL)
 	{	MessageBox(g_hwndDlg, "Ned sa vytvori objekt udalost.", "Chyba", MB_OK | MB_ICONSTOP);
 		SendMessage(g_hwndDlg, WM_COMMAND, (WPARAM)LOWORD(IDCANCEL), 0);
		return 0;
	}
	//Nekonecny cyklus vlakna, ktore bezi paralelne s cyklom hlavneho programu
	while(StavPripojeniaUSB)
	{	if(!ReadFile(USBhandle, RXbufer, 1+PocetByteUsbIn, &bytesRead, &osRead)) 
			if(GetLastError() != ERROR_IO_PENDING) 
				break;
		//Caka na dalsii prijem bajtov. Po odpojeni zariadenia sa funkcia tiez opusti, ale s chybou. Tym sa opusti while v tomto vlakne.
		if(WaitForSingleObject(ev, INFINITE) != WAIT_OBJECT_0) 
			break;
		SendMessage(g_hwndDlg, WM_RXUSB, 0, 0);
	}	
	//Automaticke odpojenie zariadenie (zatvorenie vstkych handle), ked bolo zariadenie odpojene.
	SendMessage(g_hwndDlg, WM_DISCONNECT, 0, 0);
	return 0;
}











//Procedura okna nastaveni
INT_PTR CALLBACK ProceduraDialogu2(HWND hwndDlg, UINT Message, WPARAM wParam, LPARAM lParam)
{   
	//spracovanie sprav adresovanych oknu
    switch(Message)
    {   
    	// definicie a udalosti pri vytvoreni okna
		case WM_INITDIALOG:
        {   //Spristupnenie rukovate hlavneho dialogoveho okna na globalnej urovni.
			g_hwndDlg2 = hwndDlg;
							
		}

      	//nastavenie pozadia dialogoveho okna a inych jeho prvkov
        case WM_CTLCOLORSTATIC:
      	{    SetBkMode((HDC)wParam, TRANSPARENT);
             return (INT_PTR)g_pozadieDlg;
       	}    
        
    	
        case WM_CTLCOLORDLG:
      	{    SetBkMode((HDC)wParam, TRANSPARENT);
             return (INT_PTR)g_pozadie;
       	}    
        	
		case WM_COMMAND:
		{	switch(LOWORD(wParam))
			{	
				if(StavPripojeniaUSB)        		 
				{					
					//Obsluha okienka adresy.
				    case ID_EDIT_Adresa:
				 	{	// horny word wParam spravy WM_COMMAND posiela oznamovacie spravy o diani v prvkoch. (nejedna sa o samostatne spravy)
						switch(HIWORD(wParam))
						{   //tuto spravu posle editbox, ked sa v nom meni pocet napisanych znakov
							case EN_CHANGE:
						    {	//Vysielanie znak po znaku okamzite pocas pisania do Tx okienka.
								memset(TextEditTx, 0, sizeof(TextEditTx));
								memset(TXbufer, 0, sizeof(TXbufer));
								
								//Obmedzenie maximalneho poctu znakov v okienku adresy na 5. Maximalne moze adresa obsahovat 5 znakov
								SendDlgItemMessage(hwndDlg, ID_EDIT_Adresa, EM_SETLIMITTEXT, 5, NULL);
								
								//Nacitanie textu z okienka edit2
								PocetZnakovAdresy = GetDlgItemText(hwndDlg, ID_EDIT_Adresa, TextAdresy, 10); 							
								//PocetZnakovAdresy = GetWindowTextLength(GetDlgItem(hwndDlg, ID_EDIT_Adresa));
								
								//Minimalne moze adresa obsahovat 3 znaky. Ak je v okienku menej ako 3 znaky, zvysne cisla budu 0.
								if((PocetZnakovAdresy < 3))
									PocetZnakovAdresy = 3;
								
								TXbufer[0] = 0x00;		//Musi byt 0x00	
								TXbufer[1] = NastavenieAdresyRFM75;		//Ovladaci kod, podla ktoreho PIC rozpozna, ze prisiel znak.							
								TXbufer[2] = PocetZnakovAdresy;							//Oznamenie PIC obvodu, kolko znakov posielam do paketu.
								for(int f = 0; f < PocetZnakovAdresy; f++)	
									TXbufer[5+f] = TextAdresy[f];
									
								//Cislo[34] = DlzkaSpravyRx;	
								//Cislo[2] = 10;	
								DWORD writen;
								WriteFile(USBhandle, TXbufer, 1+PocetByteUsbOut, &writen, &osWrite);
								// Prekreslenie bitmapy
								//RedrawWindow(hwndDlg, &rect_hl, NULL, RDW_UPDATENOW | RDW_INVALIDATE); 
							}
						    break;	
						    //odoslanie adresy a obsahu TX okienka aktualneho okna po ziskani fokusu okienka adresy
						  	case EN_SETFOCUS:
						    {  	
								SendMessage(g_hwndDlg2, WM_COMMAND, (WPARAM)MAKELONG(ID_EDIT_Adresa, EN_CHANGE), 0);
								//SendMessage(g_hwndDlg2, WM_COMMAND, (WPARAM)MAKELONG(ID_EDIT1, EN_CHANGE), 0);
							}	
							break;
						}       
				 		break;
				 	}				
								
				
					//Obsluha vysielacieho TX okienka.
				    case ID_EDIT1:
				 	{	// horny word wParam spravy WM_COMMAND posiela oznamovacie spravy o diani v prvkoch. (nejedna sa o samostatne spravy)
						switch(HIWORD(wParam))
						{   //tuto spravu posle editbox, ked sa v nom meni pocet napisanych znakov
							case EN_CHANGE:
						    {	//Vysielanie znak po znaku okamzite pocas pisania do Tx okienka.
								memset(TextEditTx, 0, sizeof(TextEditTx));
								memset(TXbufer, 0, sizeof(TXbufer));
								GetDlgItemText(hwndDlg, ID_EDIT1, TextEditTx, 2000); //minimalne +1 musi byt pridane kvoli nulovemu zakoncovaciemu znaku
								DlzkaSpravyRx = GetWindowTextLength(GetDlgItem(hwndDlg, ID_EDIT1));
								TXbufer[0] = 0x00;		//Musi byt 0x00	
								TXbufer[1] = DataDoRFM75;		//Ovladaci kod, podla ktoreho PIC rozpozna, ze prisiel znak.							
								TXbufer[2] = DlzkaSpravyRx;							//Oznamenie PIC obvodu, kolko znakov posielam do paketu.
								for(int f = 0; f < DlzkaSpravyRx; f++)	
									TXbufer[5+f] = TextEditTx[f];
									
								//Cislo[34] = DlzkaSpravyRx;	
								//Cislo[2] = 10;	
								DWORD writen;
								WriteFile(USBhandle, TXbufer, 1+PocetByteUsbOut, &writen, &osWrite);
								// Prekreslenie bitmapy
								//RedrawWindow(hwndDlg, &rect_hl, NULL, RDW_UPDATENOW | RDW_INVALIDATE); 
							}
						    break;	
							//odoslanie adresy a obsahu TX okienka aktualneho okna po ziskani fokusu TX okienka
						  	case EN_SETFOCUS:
						    {  	
						    	SendMessage(g_hwndDlg2, WM_COMMAND, (WPARAM)MAKELONG(ID_EDIT_Adresa, EN_CHANGE), 0);
						    	//SendMessage(g_hwndDlg2, WM_COMMAND, (WPARAM)MAKELONG(ID_EDIT1, EN_CHANGE), 0);
						    	
								//ked kliknem kurzorom do okienka editboxu, vymaze sa jeho prednastaveny text...
						       	//SetDlgItemText(hwndDlg, ID_EDIT1_4, TEXT(""));
						       	//Nastavi editbox na pisanie
						        //SendDlgItemMessage(g_hwndDlg, ID_EDIT1, EM_SETREADONLY, FALSE, 0);
						        //MessageBox(hwndDlg, "Ok", "Sprava", MB_OK);
				     			//BalonovyNapis(hwndDlg, IDC_EDITBOX5, L"Vysielanie");
							}	
							break;			  
						}       
				 		break;
				 	}				             					
				}

				// Zatvorenie dialogoveho okna  
				case IDCANCEL:
				{						
					EndDialog(hwndDlg, LOWORD(wParam));
					PostQuitMessage (0);				
					break;
				}
			 }			
            return TRUE;
        }
 	    
        
        
        case WM_PAINT: 
        {   PAINTSTRUCT ps;
            SIZE size;
			// Ziskanie handle vykreslovania do okna
            HDC hdc = BeginPaint(hwndDlg, &ps);               
			//Zobrazenie frekvencie
			Text(hdc, &size, "Adresa:", -1, 5, 4, RGB(0,0,120), 10, 0, "Segoe UI");						
			EndPaint(hwndDlg, &ps);       
            return TRUE;
        }   		
 	
    }
    return FALSE;
}    






//Procedura okna nastaveni
INT_PTR CALLBACK ProceduraDialogu3(HWND hwndDlg, UINT Message, WPARAM wParam, LPARAM lParam)
{   
	//spracovanie sprav adresovanych oknu
    switch(Message)
    {   
    	// definicie a udalosti pri vytvoreni okna
		case WM_INITDIALOG:
        {   //Spristupnenie rukovate hlavneho dialogoveho okna na globalnej urovni.
			g_hwndDlg3 = hwndDlg;
		}

      	//nastavenie pozadia dialogoveho okna a inych jeho prvkov
        case WM_CTLCOLORSTATIC:
      	{    SetBkMode((HDC)wParam, TRANSPARENT);
             return (INT_PTR)g_pozadieDlg;
       	}    
        
        case WM_CTLCOLORDLG:
      	{    SetBkMode((HDC)wParam, TRANSPARENT);
             return (INT_PTR)g_pozadie;
       	}    
        	
		case WM_COMMAND:
		{	switch(LOWORD(wParam))
			{	
				if(StavPripojeniaUSB)        		 
				{					
					//Obsluha okienka adresy.
				    case ID_EDIT_Adresa_3:
				 	{	// horny word wParam spravy WM_COMMAND posiela oznamovacie spravy o diani v prvkoch. (nejedna sa o samostatne spravy)
						switch(HIWORD(wParam))
						{   //tuto spravu posle editbox, ked sa v nom meni pocet napisanych znakov
							case EN_CHANGE:
						    {	//Vysielanie znak po znaku okamzite pocas pisania do Tx okienka.
								memset(TextEditTx, 0, sizeof(TextEditTx));
								memset(TXbufer, 0, sizeof(TXbufer));
								
								//Obmedzenie maximalneho poctu znakov v okienku adresy na 5. Maximalne moze adresa obsahovat 5 znakov
								SendDlgItemMessage(hwndDlg, ID_EDIT_Adresa_3, EM_SETLIMITTEXT, 5, NULL);
								
								//Nacitanie textu z okienka edit2
								PocetZnakovAdresy = GetDlgItemText(hwndDlg, ID_EDIT_Adresa_3, TextAdresy, 10); 							
								//PocetZnakovAdresy = GetWindowTextLength(GetDlgItem(hwndDlg, ID_EDIT_Adresa));
								
								//Minimalne moze adresa obsahovat 3 znaky. Ak je v okienku menej ako 3 znaky, zvysne cisla budu 0.
								if((PocetZnakovAdresy < 3))
									PocetZnakovAdresy = 3;
								
								TXbufer[0] = 0x00;		//Musi byt 0x00	
								TXbufer[1] = NastavenieAdresyRFM75;		//Ovladaci kod, podla ktoreho PIC rozpozna, ze prisiel znak.							
								TXbufer[2] = PocetZnakovAdresy;							//Oznamenie PIC obvodu, kolko znakov posielam do paketu.
								for(int f = 0; f < PocetZnakovAdresy; f++)	
									TXbufer[5+f] = TextAdresy[f];
									
								//Cislo[34] = DlzkaSpravyRx;	
								//Cislo[2] = 10;	
								DWORD writen;
								WriteFile(USBhandle, TXbufer, 1+PocetByteUsbOut, &writen, &osWrite);
								// Prekreslenie bitmapy
								//RedrawWindow(hwndDlg, &rect_hl, NULL, RDW_UPDATENOW | RDW_INVALIDATE); 
							}
						    break;
							//odoslanie adresy a obsahu TX okienka aktualneho okna po ziskani fokusu
						  	case EN_SETFOCUS:
						    {  	
								SendMessage(g_hwndDlg3, WM_COMMAND, (WPARAM)MAKELONG(ID_EDIT_Adresa_3, EN_CHANGE), 0);
								//SendMessage(g_hwndDlg3, WM_COMMAND, (WPARAM)MAKELONG(ID_EDIT1_3, EN_CHANGE), 0);
							}
							break;					  
						}       
				 		break;
				 	}				
								
				
					//Obsluha vysielacieho TX okienka.
				    case ID_EDIT1_3:
				 	{	// horny word wParam spravy WM_COMMAND posiela oznamovacie spravy o diani v prvkoch. (nejedna sa o samostatne spravy)
						switch(HIWORD(wParam))
						{   //tuto spravu posle editbox, ked sa v nom meni pocet napisanych znakov
							case EN_CHANGE:
						    {	//Vysielanie znak po znaku okamzite pocas pisania do Tx okienka.
								memset(TextEditTx, 0, sizeof(TextEditTx));
								memset(TXbufer, 0, sizeof(TXbufer));
								GetDlgItemText(hwndDlg, ID_EDIT1_3, TextEditTx, 2000); //minimalne +1 musi byt pridane kvoli nulovemu zakoncovaciemu znaku
								DlzkaSpravyRx = GetWindowTextLength(GetDlgItem(hwndDlg, ID_EDIT1_3));
								TXbufer[0] = 0x00;		//Musi byt 0x00	
								TXbufer[1] = DataDoRFM75;		//Ovladaci kod, podla ktoreho PIC rozpozna, ze prisiel znak.							
								TXbufer[2] = DlzkaSpravyRx;							//Oznamenie PIC obvodu, kolko znakov posielam do paketu.
								for(int f = 0; f < DlzkaSpravyRx; f++)	
									TXbufer[5+f] = TextEditTx[f];
									
								//Cislo[34] = DlzkaSpravyRx;	
								//Cislo[2] = 10;	
								DWORD writen;
								WriteFile(USBhandle, TXbufer, 1+PocetByteUsbOut, &writen, &osWrite);
								// Prekreslenie bitmapy
								//RedrawWindow(hwndDlg, &rect_hl, NULL, RDW_UPDATENOW | RDW_INVALIDATE); 
							}
						    break;				
							//odoslanie adresy a obsahu TX okienka aktualneho okna po ziskani fokusu
						  	case EN_SETFOCUS:
						    {  	
								SendMessage(g_hwndDlg3, WM_COMMAND, (WPARAM)MAKELONG(ID_EDIT_Adresa_3, EN_CHANGE), 0);
								//SendMessage(g_hwndDlg3, WM_COMMAND, (WPARAM)MAKELONG(ID_EDIT1_3, EN_CHANGE), 0);
							}	  
							break;		  	
						}       
				 		break;
				 	}				             					
				}
			 		
					 
					 			 			 
				// Zatvorenie dialogoveho okna  
				case IDCANCEL:
				{						
					EndDialog(hwndDlg, LOWORD(wParam));
					PostQuitMessage (0);				
					break;
				}
			 }			
            return TRUE;
        }
 	    
        
        
        case WM_PAINT: 
        {   PAINTSTRUCT ps;
            SIZE size;
			// Ziskanie handle vykreslovania do okna
            HDC hdc = BeginPaint(hwndDlg, &ps);               
			//Zobrazenie frekvencie
			Text(hdc, &size, "Adresa:", -1, 5, 4, RGB(0,0,120), 10, 0, "Segoe UI");						
			EndPaint(hwndDlg, &ps);       
            return TRUE;
        }   		
 	
    }
    return FALSE;
}    










//Procedura okna nastaveni
INT_PTR CALLBACK ProceduraDialogu4(HWND hwndDlg, UINT Message, WPARAM wParam, LPARAM lParam)
{   
	//spracovanie sprav adresovanych oknu
    switch(Message)
    {   
    	// definicie a udalosti pri vytvoreni okna
		case WM_INITDIALOG:
        {   //Spristupnenie rukovate hlavneho dialogoveho okna na globalnej urovni.
			g_hwndDlg4 = hwndDlg;
		}

      	//nastavenie pozadia dialogoveho okna a inych jeho prvkov
        case WM_CTLCOLORSTATIC:
      	{    SetBkMode((HDC)wParam, TRANSPARENT);
             return (INT_PTR)g_pozadieDlg;
       	}    
        
        case WM_CTLCOLORDLG:
      	{    SetBkMode((HDC)wParam, TRANSPARENT);
             return (INT_PTR)g_pozadie;
       	}    
        	
		case WM_COMMAND:
		{	switch(LOWORD(wParam))
			{	
				if(StavPripojeniaUSB)        		 
				{					
					//Obsluha okienka adresy.
				    case ID_EDIT_Adresa_4:
				 	{	// horny word wParam spravy WM_COMMAND posiela oznamovacie spravy o diani v prvkoch. (nejedna sa o samostatne spravy)
						switch(HIWORD(wParam))
						{   //tuto spravu posle editbox, ked sa v nom meni pocet napisanych znakov
							case EN_CHANGE:
						    {	//Vysielanie znak po znaku okamzite pocas pisania do Tx okienka.
								memset(TextEditTx, 0, sizeof(TextEditTx));
								memset(TXbufer, 0, sizeof(TXbufer));
								
								//Obmedzenie maximalneho poctu znakov v okienku adresy na 5. Maximalne moze adresa obsahovat 5 znakov
								SendDlgItemMessage(hwndDlg, ID_EDIT_Adresa_4, EM_SETLIMITTEXT, 5, NULL);
								
								//Nacitanie textu z okienka edit2
								PocetZnakovAdresy = GetDlgItemText(hwndDlg, ID_EDIT_Adresa_4, TextAdresy, 10); 							
								//PocetZnakovAdresy = GetWindowTextLength(GetDlgItem(hwndDlg, ID_EDIT_Adresa));
								
								//Minimalne moze adresa obsahovat 3 znaky. Ak je v okienku menej ako 3 znaky, zvysne cisla budu 0.
								if((PocetZnakovAdresy < 3))
									PocetZnakovAdresy = 3;
								
								TXbufer[0] = 0x00;		//Musi byt 0x00	
								TXbufer[1] = NastavenieAdresyRFM75;		//Ovladaci kod, podla ktoreho PIC rozpozna, ze prisiel znak.							
								TXbufer[2] = PocetZnakovAdresy;							//Oznamenie PIC obvodu, kolko znakov posielam do paketu.
								for(int f = 0; f < PocetZnakovAdresy; f++)	
									TXbufer[5+f] = TextAdresy[f];
									
								//Cislo[34] = DlzkaSpravyRx;	
								//Cislo[2] = 10;	
								DWORD writen;
								WriteFile(USBhandle, TXbufer, 1+PocetByteUsbOut, &writen, &osWrite);
								// Prekreslenie bitmapy
								//RedrawWindow(hwndDlg, &rect_hl, NULL, RDW_UPDATENOW | RDW_INVALIDATE); 
							}
						    break;					  
						}       
				 		break;
				 	}				
								
				
					//Obsluha vysielacieho TX okienka.
				    case ID_EDIT1_4:
				 	{	// horny word wParam spravy WM_COMMAND posiela oznamovacie spravy o diani v prvkoch. (nejedna sa o samostatne spravy)
						switch(HIWORD(wParam))
						{   //tuto spravu posle editbox, ked sa v nom meni pocet napisanych znakov
							case EN_CHANGE:
						    {	//Vysielanie znak po znaku okamzite pocas pisania do Tx okienka.
								memset(TextEditTx, 0, sizeof(TextEditTx));
								memset(TXbufer, 0, sizeof(TXbufer));
								GetDlgItemText(hwndDlg, ID_EDIT1_4, TextEditTx, 2000); //minimalne +1 musi byt pridane kvoli nulovemu zakoncovaciemu znaku
								DlzkaSpravyRx = GetWindowTextLength(GetDlgItem(hwndDlg, ID_EDIT1_4));
								TXbufer[0] = 0x00;		//Musi byt 0x00	
								TXbufer[1] = DataDoRFM75;		//Ovladaci kod, podla ktoreho PIC rozpozna, ze prisiel znak.							
								TXbufer[2] = DlzkaSpravyRx;							//Oznamenie PIC obvodu, kolko znakov posielam do paketu.
								for(int f = 0; f < DlzkaSpravyRx; f++)	
									TXbufer[5+f] = TextEditTx[f];
									
								//Cislo[34] = DlzkaSpravyRx;	
								//Cislo[2] = 10;	
								DWORD writen;
								WriteFile(USBhandle, TXbufer, 1+PocetByteUsbOut, &writen, &osWrite);
								// Prekreslenie bitmapy
								//RedrawWindow(hwndDlg, &rect_hl, NULL, RDW_UPDATENOW | RDW_INVALIDATE); 
							}
						    break;
							//tuto spravu posle editbox raz vtedy, ked ziska fokus
						  	case EN_SETFOCUS:
						    {  	//ked kliknem kurzorom do okienka editboxu, vymaze sa jeho prednastaveny text...
						       	//SetDlgItemText(hwndDlg, ID_EDIT1_4, TEXT(""));
						       	//Nastavi editbox na pisanie
						        //SendDlgItemMessage(g_hwndDlg, ID_EDIT1, EM_SETREADONLY, FALSE, 0);
						        //MessageBox(hwndDlg, "Ok", "Sprava", MB_OK);
				     			//BalonovyNapis(hwndDlg, IDC_EDITBOX5, L"Vysielanie");
							}					  		  	
						}       
				 		break;
				 	}				             					
				}
			 		
					 
					 			 			 
				// Zatvorenie dialogoveho okna  
				case IDCANCEL:
				{						
					EndDialog(hwndDlg, LOWORD(wParam));
					PostQuitMessage (0);				
					break;
				}
			 }			
            return TRUE;
        }
 	    
        
        
        case WM_PAINT: 
        {   PAINTSTRUCT ps;
            SIZE size;
			// Ziskanie handle vykreslovania do okna
            HDC hdc = BeginPaint(hwndDlg, &ps);               
			//Zobrazenie frekvencie
			Text(hdc, &size, "Adresa:", -1, 5, 4, RGB(0,0,120), 10, 0, "Segoe UI");						
			EndPaint(hwndDlg, &ps);       
            return TRUE;
        }   		
 	
    }
    return FALSE;
}    










//////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////// HLAVNE OKNO //////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////


//Procedura hlavneho okna
INT_PTR CALLBACK ProceduraDialogu(HWND hwndDlg, UINT Message, WPARAM wParam, LPARAM lParam)
{   
	//spracovanie sprav adresovanych oknu
    switch(Message)
    {   
    	// definicie a udalosti pri vytvoreni okna
		case WM_INITDIALOG:
        {   //Spristupnenie rukovate hlavneho dialogoveho okna na globalnej urovni.
			g_hwndDlg = hwndDlg;
			//Vytvorenie timeru pre spravu WM_TIMER
			SetTimer(hwndDlg, _Casovac1, _CasTimer1, NULL); 
			//Pozadie hlavneho dialogoveho okna.
			g_pozadieDlg = CreatePatternBrush(LoadBitmap(g_hInstance, MAKEINTRESOURCE(ID_POZADIE_DLG)));
			//Pozadie okienka bitmapy
			g_pozadie = CreatePatternBrush(LoadBitmap(g_hInstance, MAKEINTRESOURCE(ID_POZADIE_BMP))); 
			//vlozenie vlastneho kurzoru do okna
			SetClassLong(hwndDlg, GCL_HCURSOR,(LONG_PTR)LoadCursor(g_hInstance, MAKEINTRESOURCE(ID_CURSOR)));
			//Vlozenie vlastnej ikony do programu
			SetClassLong(hwndDlg, GCL_HICON,(LONG_PTR)LoadIcon(g_hInstance, MAKEINTRESOURCE(ID_ICON)));  
			SetClassLong(hwndDlg, GCL_HICONSM,(LONG_PTR)LoadIcon(g_hInstance, MAKEINTRESOURCE(ID_ICON)));  
			//Tien okna
			SetClassLong(hwndDlg, GCL_STYLE,(LONG_PTR)CS_DROPSHADOW);   			
			//nacitanie vlastneho kurzoru do systemovej triedy "BUTTON"     
		    SetClassLong(GetDlgItem(hwndDlg, ID_BUTTON3), GCL_HCURSOR,(LONG_PTR)LoadCursor(g_hInstance, MAKEINTRESOURCE(ID_CURSOR3)));  
		    //nacitanie vlastneho kurzoru do systemovej triedy "TRACKBAR"     
			SetClassLong(GetDlgItem(hwndDlg, ID_TRACK_Freq), GCL_HCURSOR,(LONG_PTR)LoadCursor(g_hInstance, MAKEINTRESOURCE(ID_CURSOR4)));
		    
			//SendDlgItemMessage(hwndDlg, ID_EDIT1, EM_SETREADONLY, 1, 0);  
			
			FrekvenciaRX = 	10;//127;
			//Nastavenie rozsahu Trackbaru frekvencie
			SendDlgItemMessage(hwndDlg, ID_TRACK_Freq, TBM_SETRANGE,TRUE, MAKELONG(0,127));	
			//Nastavenie pociatocnej pozicie Trackbaru frekvencie
			SendDlgItemMessage(hwndDlg, ID_TRACK_Freq, TBM_SETPOS, TRUE, FrekvenciaRX);	
			//Nastavenie frekvencie znaciek trackbaru frekvencie
			SendDlgItemMessage(hwndDlg, ID_TRACK_Freq, TBM_SETTICFREQ, 10, NULL);	
			//Nastavenie rychleho posunu klavesovymi sipkami
			SendDlgItemMessage(hwndDlg, ID_TRACK_Freq, TBM_SETLINESIZE, 0, 10);	
			//SendDlgItemMessage(hwndDlg, ID_TRACK_Freq, TBM_SETTHUMBLENGTH, 30, 0);				
			//Naplnenie comboboxu pre vyber kanala hodnotami a nastavenie vychodzej hodnoty
			SendDlgItemMessage(hwndDlg, ID_COMBO_kanal, CB_ADDSTRING, 0, (LPARAM)"1");  	
			SendDlgItemMessage(hwndDlg, ID_COMBO_kanal, CB_ADDSTRING, 0, (LPARAM)"2");  	
			SendDlgItemMessage(hwndDlg, ID_COMBO_kanal, CB_ADDSTRING, 0, (LPARAM)"3");  	
			SendDlgItemMessage(hwndDlg, ID_COMBO_kanal, CB_SETCURSEL, 0, 0);

			//Nacitanie obsahu registrov
			ReadRegistry();	
			//Nastavenie polohy a rozmerov hlavneho dialogoveho okna
			SetWindowPos(hwndDlg, HWND_TOP/*HWND_TOPMOST*/, LOWORD(g_dwWindowPos), HIWORD(g_dwWindowPos), _SirkaHlOkna, _VyskaHlOkna, SWP_DRAWFRAME);	
			//Nacitanie obrazkov o pripojenom / odpojenom stave USB
			g_bmp_z = LoadBitmap(g_hInstance, MAKEINTRESOURCE(ID_BMP_USB_Z));
			g_bmp_v = LoadBitmap(g_hInstance, MAKEINTRESOURCE(ID_BMP_USB_V));			
			
			//**************************** VYTVORENIE PAMATOVEJ BITMAPY PRE VYKRESLOVANIE OBSAHU HLAVNEHO OKNA ****************************************
			GetClientRect(hwndDlg, &rect_okna); 
		    HDC hdcScreen = GetDC(hwndDlg); 
		    //vytvorii pamatove HDC kompatibilne s HDC okna
		    g_hdcMemWindow = CreateCompatibleDC(hdcScreen); 
		    ///Vytvori rastrovy obrazok kompatibilny s oknom.
		    HBITMAP hBitmap = CreateCompatibleBitmap(hdcScreen, rect_okna.right, rect_okna.bottom); 
		    SelectObject(g_hdcMemWindow, hBitmap);   
			//Prvotne vyplnenie bitmapy texturou pozadia
		    FillRect(g_hdcMemWindow, &rect_okna, g_pozadie);
		    ReleaseDC(hwndDlg, hdcScreen);
		    DeleteObject(hBitmap);  
				
		//	DialogBox(g_hInstance, MAKEINTRESOURCE(ID_DIALOG_2), NULL, (DLGPROC)ProceduraDialogu2);
			
 			CreateDialog(g_hInstance, MAKEINTRESOURCE(ID_DIALOG_2), g_hwndDlg, (DLGPROC)ProceduraDialogu2);
  			CreateDialog(g_hInstance, MAKEINTRESOURCE(ID_DIALOG_3), g_hwndDlg, (DLGPROC)ProceduraDialogu3);
  			CreateDialog(g_hInstance, MAKEINTRESOURCE(ID_DIALOG_4), g_hwndDlg, (DLGPROC)ProceduraDialogu4);
  			
  			//Nastavenie fontu Editboxov
			GetObject(GetStockObject(DEFAULT_GUI_FONT), sizeof(logFont2), &logFont2);
			lstrcpy(logFont2.lfFaceName, TEXT("Courier New"));
			//lstrcpy(logFont2.lfFaceName, TEXT("Arial"));
			logFont2.lfHeight = -15;
			logFont2.lfWeight = 0;//600;		 
			hfEdit = CreateFontIndirect(&logFont2);	 
			SendDlgItemMessage(g_hwndDlg2, ID_EDIT1, WM_SETFONT, (WPARAM)hfEdit, (LPARAM)TRUE);  
			SendDlgItemMessage(g_hwndDlg2, ID_EDIT2, WM_SETFONT, (WPARAM)hfEdit, (LPARAM)TRUE); 
			SendDlgItemMessage(g_hwndDlg2, ID_EDIT_Adresa, WM_SETFONT, (WPARAM)hfEdit, (LPARAM)TRUE); 
			SendDlgItemMessage(g_hwndDlg3, ID_EDIT1_3, WM_SETFONT, (WPARAM)hfEdit, (LPARAM)TRUE);  
			SendDlgItemMessage(g_hwndDlg3, ID_EDIT2_3, WM_SETFONT, (WPARAM)hfEdit, (LPARAM)TRUE); 
			SendDlgItemMessage(g_hwndDlg3, ID_EDIT_Adresa_3, WM_SETFONT, (WPARAM)hfEdit, (LPARAM)TRUE); 
			SendDlgItemMessage(g_hwndDlg4, ID_EDIT1_4, WM_SETFONT, (WPARAM)hfEdit, (LPARAM)TRUE);  
			SendDlgItemMessage(g_hwndDlg4, ID_EDIT2_4, WM_SETFONT, (WPARAM)hfEdit, (LPARAM)TRUE); 
			SendDlgItemMessage(g_hwndDlg4, ID_EDIT_Adresa_4, WM_SETFONT, (WPARAM)hfEdit, (LPARAM)TRUE); 

  			
  			
  			ShowWindow(g_hwndDlg2, SW_SHOW); 
  			SendMessage(hwndDlg, WM_MOVE, 0, 0);
			//ShowWindow(hwndDlg, g_nCmdShow); 
			
			FILE *fa;
			fa = fopen(NazovSuboru, "w+");	
			fprintf(fa, "");	
			fclose(fa);
			
		  	return TRUE;
        }   
        
                
        
        
        //nastavenie pozadia dialogoveho okna a inych jeho prvkov
		//case WM_CTLCOLORLISTBOX:
    	//case WM_CTLCOLOREDIT:
        case WM_CTLCOLORSTATIC:
        case WM_CTLCOLORDLG:
      {    SetBkMode((HDC)wParam, TRANSPARENT);
             return (INT_PTR)g_pozadie;
       }    
        
 		

	
		// Handler uzivatelsky definovanej spravy zasielanej z procedury vlakna.
		//Tu sa spracuva vsetko, co sa tyka prijatych sprav z USB
		case WM_RXUSB:
		{	if(StavPripojeniaUSB)
			{	//Skopirovanie vsetkych prijatych bajtov z RXbufer[] do pola Cislo[], z ktoreho sa zobrazuje v obsluhe spravy WM_PAINT obsah USB RAM
				memcpy(Cislo, RXbufer,  1+PocetByteUsbIn);	
				
				

				// Vypis Rx paketu do suboru
				FILE *fa;
				int x,y,
					byte_v_riadku = 8,
					byte_v_stlpci = 8;
				fa = fopen(NazovSuboru, "a+");
				for(y = 0; y < byte_v_riadku; y++)
				{	for(x = 1; x <= byte_v_stlpci; x++)
						fprintf(fa, "%.2X ",RXbufer[y * byte_v_riadku + x]);
					fprintf(fa, "\n");	
				}
				fprintf(fa, "\n\n");	
				fclose(fa);	
				
				
				//Prijem znak po znaku do rx okienka.
				if(Cislo[1] == Data_Z_RFM75)		//Kod z PIC obvodu o tom, ze prisli data do modulu RFM75
				{	PocetBytePaketu = Cislo[2];
					memset(CopyChar, 0, sizeof(CopyChar));
					for(int f = 0; f < PocetBytePaketu; f++)
						CopyChar[f] = Cislo[5+5+f];
					
					SendDlgItemMessage(g_hwndDlg2, ID_EDIT2, WM_SETTEXT, FALSE, (LPARAM)CopyChar);
					SendDlgItemMessage(g_hwndDlg3, ID_EDIT2_3, WM_SETTEXT, FALSE, (LPARAM)CopyChar);
					
					//SendDlgItemMessage(hwndDlg, ID_EDIT2, EM_REPLACESEL, FALSE, (LPARAM)CopyChar);
					//SetDlgItemText(hwndDlg, ID_EDIT2, TEXT("asdf"));								
					//memset(Cislo, 0, sizeof(Cislo));								
					memset(TXbufer, 0, sizeof(TXbufer));															
				}
				
				//Kod z PIC obvodu o tom, ze sa zmenila frekvencia modulu RFM75
				if(Cislo[1] == ZmenaFrekvencieRFM75)		
				{	FrekvenciaRX = 	Cislo[3];		
					//SendDlgItemMessage(g_hwndDlg, ID_TRACK_Freq, TBM_SETPOS, TRUE, Cislo[3]);
				}

//				if(Cislo[1] == 0xBB)
//				{	// spetne potvrdzujuce nastavenie trackbaru frekvencie M
//					SendDlgItemMessage(g_hwndDlg, ID_TRACK_Freq, TBM_SETPOS, TRUE, Cislo[4]);	
//				}
				
				RedrawWindow(hwndDlg, &rect_hl, NULL, RDW_UPDATENOW | RDW_INVALIDATE);			
			}			
			
			return TRUE;
		}
	
	
	
	
	
		// Odpojenie od USB zariadenia
		case WM_DISCONNECT:
		{	StavPripojeniaUSB = 0; 		 				 
			//Zatvorenie portu
			CloseUSB();
			Adresa = 0;
			int i;
			for(i = 0; i < sizeof(iManufactured); i++)
				iManufactured[i] = 0; 
			for(i = 0; i < sizeof(iProduct); i++)
				iProduct[i] = 0; 		
			deviceAttributes.ProductID = NULL;
			deviceAttributes.VendorID = NULL;
			deviceAttributes.VersionNumber = NULL;
			// Prekreslenie oblasti okna, kde je "LED indikator" pripojenia
			RedrawWindow(hwndDlg, NULL, NULL, RDW_UPDATENOW | RDW_INVALIDATE);  
			//Pozastavenie cinnosti vlakna
			SuspendThread(ghThread);
			//Vytvorenie timeru pre spravu WM_TIMER, v ktorej sa opakovane pokusa nanovo pripojit k USB zariadeniu
			SetTimer(hwndDlg, _Casovac1, _CasTimer1, NULL); 
			return TRUE;
		}
	
	
	
	
	
	
	
       
		case WM_TIMER:
        {   switch(wParam)
			{	//automaticke pripojenie zariadenia, ked je dostupne.
				case _Casovac1: 
				{	//Ak sa pripojenie podarilo, vytvor vlakno udalosti prijmu z USB a zastav opakovane pokusy o pripajanie
				 	if(StavPripojeniaUSB)        		 
					{	//Vytvorenie vlakna pre udalos prijmu z USB				    				
						ghThread = CreateThread(NULL, 0, ThreadProc, NULL, 0, 0); 	
						//Zastavenie casovaca pre WM_TIMER, kde su zabezpecene opakovane pokusy o pripojenie k zariadeniu.
		 				KillTimer(hwndDlg, _Casovac1);   
						//Vytvorenie timeru pre posielanie inicializacneho kodu do PIC obvodu.
						SetTimer(hwndDlg, _Casovac2, _CasTimer2, NULL); 	
					    //Prekreslenie hlavneho okna
		                RedrawWindow(hwndDlg, NULL, NULL, RDW_UPDATENOW | RDW_INVALIDATE);  
					}
					else 
						//Pokusy o pripajanie k USB zariadeniu, ked je odpojene
						StavPripojeniaUSB = usbOpenDevice(hwndDlg, (VendorId), vendorName, (ProductId), productName, (_VersionNumber));		 
				}
				//Automaticka inicializacia modulu RFM75, ked je PIC obvod sparovany s PC na USB porte.
				case _Casovac2: 
				{	//Ak sa inicializacia modulu RFM75 podarila, vypni Timer2. (Tj. PIC obvod poslal potvrdzujuci kod.)
				 	if(Cislo[1] == Init_RFM75)        		 
					{	//Zastavenie casovaca pre WM_TIMER, kde su zabezpecene opakovane pokusy o pripojenie k zariadeniu.
		 				KillTimer(hwndDlg, _Casovac2);  
						//Nastav posuvnik frekvencie do aktualne nastavenej frekvencie modulu RFM75
						SendDlgItemMessage(hwndDlg, ID_TRACK_Freq, TBM_SETPOS, TRUE, Cislo[3]);
						FrekvenciaRX = Cislo[3];
						//Uvodne nastavenie adries na kanaloch 0 a 1 po pripojeni na USB a inicializacii
						SetDlgItemText(g_hwndDlg2, ID_EDIT_Adresa, Adresa_P0);
						SetDlgItemText(g_hwndDlg3, ID_EDIT_Adresa_3, Adresa_P1);
						//SendDlgItemMessage(g_hwndDlg2, ID_EDIT_Adresa, WM_SETTEXT, FALSE, (LPARAM)"sdf");
						//Odoslanie spravy do obsluhy okienka adresy pre kanal 0, aby sa fyzicky odoslala do modulu RFM75.
						SendMessage(g_hwndDlg2, WM_COMMAND, (WPARAM)MAKELONG(ID_EDIT_Adresa,EN_CHANGE), 0);
						RedrawWindow(hwndDlg, &rect_hl, NULL, RDW_UPDATENOW | RDW_INVALIDATE);			
					}
					else
					{	//Vyzva k inicializacii
						TXbufer[0] = 0x00;			//Musi byt 0x00	
						TXbufer[1] = Init_RFM75;	//Ovladaci kod, podla ktoreho PIC rozpozna, ze ma inicializovat hodnoty nastaveni.
						TXbufer[4] = Frekvencia_RFM75;										
						DWORD writen;
						WriteFile(USBhandle, TXbufer, 1+PocetByteUsbOut, &writen, &osWrite);
					} 
				}
				break;					
			}
			break;
        }  
	

	
	
	
	

   		// Obsluha spravy pri posuvani Hlavneho okna mysou.
        case WM_MOVE:
        {	RECT rect;
			//Ziskanie aktualnych rozmerov obrazovky pocitaca.
			rect = RozmeryOkna(hwndDlg);
			// Posun okna nastavenia v sulade s posunom hlavneho okna
			SetWindowPos(g_hwndDlg2, HWND_TOP/*HWND_TOP/*HWND_TOPMOST*/, rect.left+3, rect.bottom, _SirkaHlOkna-5, _VyskaOkna2, SWP_DRAWFRAME/*SWP_FRAMECHANGED*/);	

			SetWindowPos(g_hwndDlg3, HWND_TOP/*HWND_TOP/*HWND_TOPMOST*/, rect.right, rect.bottom, _SirkaHlOkna-5, _VyskaOkna2, SWP_DRAWFRAME/*SWP_FRAMECHANGED*/);	

			SetWindowPos(g_hwndDlg4, HWND_TOP/*HWND_TOP/*HWND_TOPMOST*/, rect.left-_SirkaHlOkna+6, rect.bottom, _SirkaHlOkna-5, _VyskaOkna2, SWP_DRAWFRAME/*SWP_FRAMECHANGED*/);	

        	return TRUE;	
        }
   
	
	
	
	
		case WM_HSCROLL:
      	{	      	
      		HWND TRACKBAR_Freq = GetDlgItem(hwndDlg, ID_TRACK_Freq);
      		
      		if((HWND)TRACKBAR_Freq == (HWND)lParam)
			{
	      		LRESULT poziciaT = SendDlgItemMessage(hwndDlg, ID_TRACK_Freq, TBM_GETPOS, 0, 0);
				FrekvenciaTX = (int)poziciaT;
	      		memset(TXbufer, 0, sizeof(TXbufer));
	      		TXbufer[0] = 0x00;				//Musi byt 0x00	
				TXbufer[1] = ZmenaFrekvencieRFM75;	  //Ovladaci kod, podla ktoreho PIC rozpozna, ze treba zmenit frekvenciu.							
				TXbufer[4] = FrekvenciaTX;			
				DWORD writen;
				WriteFile(USBhandle, TXbufer, 1+PocetByteUsbOut, &writen, &osWrite);
				// Prekreslenie bitmapy
				//RedrawWindow(hwndDlg, &rect_hl, NULL, RDW_UPDATENOW | RDW_INVALIDATE); 
	  		}
	   		return TRUE;
      	}	
	
		
	
	
	
	
	
        	
		case WM_COMMAND:
		{	switch(LOWORD(wParam))
			{	
				if(StavPripojeniaUSB)        		 
				{	
	 	     
				
				
					//Tlacitko zapni 1
					case ID_BUTTON1:
					{ 	TXbufer[0] = 0x00;				//Musi byt 0x00		  							
						TXbufer[1] = 0x01;			
						DWORD writen;
						WriteFile(USBhandle, TXbufer, 1+PocetByteUsbOut, &writen, &osWrite);	
				    	break;
					}
					
					
				
					
					//Tlacitko zapni 2
					case ID_BUTTON2:
					{ 	TXbufer[0] = 0x00;				//Musi byt 0x00		  							
						TXbufer[1] = 0x02;			
						DWORD writen;
						WriteFile(USBhandle, TXbufer, 1+PocetByteUsbOut, &writen, &osWrite);	
				    	break;
					}
				
				
				
					//Tlacitko RESET
					case ID_BUTTON3:
					{	//Naplni vsetky polia nulami
						memset(Cislo, 0, sizeof(Cislo));
						memset(TXbufer, 0, sizeof(TXbufer));
						memset(RXbufer, 0, sizeof(RXbufer));
						
						TXbufer[0] = 0x00;				//Musi byt 0x00		  							
						TXbufer[1] = 0x03;			
						DWORD writen;
						WriteFile(USBhandle, TXbufer, 1+PocetByteUsbOut, &writen, &osWrite);
						PocitadloTransferov = 0;
						
						FILE *fa;
						fa = fopen(NazovSuboru, "w");	
						fprintf(fa, "");	
						fclose(fa);	
						// Prekreslenie bitmapy
						RedrawWindow(hwndDlg, &rect_hl, NULL, RDW_UPDATENOW | RDW_INVALIDATE); 	
						break;
					}
				
				
					
					//Vypis paketov do suboru
					case ID_BUTTON4:
					{ 	//system("\"SETUP pakety.txt\"");
						TXbufer[0] = 0x00;				//Musi byt 0x00		  							
						TXbufer[1] = 0x04;			
						DWORD writen;
						WriteFile(USBhandle, TXbufer, 1+PocetByteUsbOut, &writen, &osWrite);	
				    	break;
					}





					//Combobox pre vyber poctu ucastnikov
					case ID_COMBO_kanal:
				 	{	//Combobox posiela tuto spravu vtedy, ked pouvate zmen aktulny vber v zozname.
					 	if(HIWORD(wParam) == CBN_SELCHANGE)
					 	{
							//Ziska cislo aktualnej polozky vyberu v comboboxe		             		
					 		PocetRxTxOkien = 1 + (BYTE)SendDlgItemMessage(hwndDlg, ID_COMBO_kanal, CB_GETCURSEL, 0, 0);	
					 	
	  						if(PocetRxTxOkien == 1)
	  						{	ShowWindow(g_hwndDlg3, SW_HIDE);
							  	ShowWindow(g_hwndDlg4, SW_HIDE); 
	  						}
					 	
							if(PocetRxTxOkien == 2)
							{ 	ShowWindow(g_hwndDlg3, SW_SHOW); 
								ShowWindow(g_hwndDlg4, SW_HIDE); 
							}
							 	
							if(PocetRxTxOkien == 3)
							{	ShowWindow(g_hwndDlg3, SW_SHOW); 
								ShowWindow(g_hwndDlg4, SW_SHOW); 
							}
							
							
							
					 		SendMessage(hwndDlg, WM_MOVE, 0, 0);
					 		
						}
						break;
				 	}


				             					
				}
			 		


					 
					 			 			 
				// Zatvorenie dialogoveho okna  
				case IDCANCEL:
				{	KillTimer(hwndDlg, _Casovac1);
					CloseUSB();
					WriteRegistry(hwndDlg);
				
					DeleteDC(g_hdcMemWindow);
					DeleteObject(g_pozadieDlg);
					DeleteObject(g_pozadie);
					
					CloseHandle(hFile);
					
					EndDialog(hwndDlg, LOWORD(wParam));
					PostQuitMessage (0);
					//Beep(1100, 100);
					//Beep(800, 200);				
					break;
				}
				
			 }			
            return TRUE;
        }
        
        
    
       
	   
	   
	   
	   
	   
	   
	   
	    
        
        
        case WM_PAINT: 
        {   PAINTSTRUCT ps;
            HDC hdc;
			SIZE size;
			RECT rect;
			char buffer[1000];
			memset(buffer, 0, sizeof(buffer));
			// Ziskanie handle vykreslovania do okna
            hdc = BeginPaint(hwndDlg, &ps);   
            // Premazanie obsahu bitmapy vyplnou pozadia           
			FillRect(g_hdcMemWindow, &rect_okna, g_pozadie);
								
			//Stanovenie obdlznika kde sa zobrazuju udaje, aby sa pri roznych akciach aktualizoval len ten a neblikali prvky okna
			rect_hl.left = 0;
			rect_hl.right = rect_okna.right;
			rect_hl.top = 40;
			rect_hl.bottom = rect_okna.bottom - 100;
			//rect = RozmeryOkna(hwndDlg);
		
			//Nacitavaqnie cisel 64 bajtov RAM USB z PIC
			int x, y, pozicia = 0;
			for(y = 0; y < 5; y++)
			{	for(x = 0; x < 8; x++)
				{	pozicia++;
					Text(g_hdcMemWindow, &size, "%.2X", Cislo[pozicia], 12+x*30, 40+y*20, RGB(0,0,0), 11, 0, "Segoe UI");	
				}
			}
			
			//Zobrazenie frekvencie
			Text(g_hdcMemWindow, &size, "Frekvencia = ", -1, 5, 143, RGB(0,0,120), 10, 0, "Segoe UI");
			Text(g_hdcMemWindow, &size, "%.2d", 2400+FrekvenciaRX, 5+size.cx, 143, RGB(0,0,120), 10, 1, "Segoe UI");
			//Text(g_hdcMemWindow, &size, "%.2d", PocetZnakovAdresy, 5+size.cx, 149, RGB(0,0,120), 10, 1, "Segoe UI");
			Text(g_hdcMemWindow, &size, "MHz", -1, 87+size.cx, 143, RGB(0,0,120), 10, 0, "Segoe UI");
			
			Text(g_hdcMemWindow, &size, "Poet astnkov", -1, 113, 190, RGB(0,0,120), 10, 0, "Segoe UI");
			
			
		
	//======================================= Zobrazenie udajov o zariadeni =======================================================
			int odstup_y = 17, 
				poloha_y = 205,
				poloha_x = 10,
				velkost_pisma = 9;
			COLORREF	farba = RGB(30,70,90);
			//Zobrazenie textoveho deskriptora iManufactured				
			Text(g_hdcMemWindow, &size, "Vendor = ", -1, poloha_x, poloha_y, farba, velkost_pisma, 0, "Segoe UI");
			Text(g_hdcMemWindow, &size, iManufactured, -1, poloha_x+size.cx, poloha_y, farba, velkost_pisma, 0, "Segoe UI");
			//Zobrazenie textoveho deskriptora iProduct 			
 			Text(g_hdcMemWindow, &size, "Product = ", -1, poloha_x, poloha_y+odstup_y, farba, velkost_pisma, 0, "Segoe UI");
			Text(g_hdcMemWindow, &size, iProduct, -1, poloha_x+size.cx, poloha_y+odstup_y, farba, velkost_pisma, 0, "Segoe UI");	
			//Zobrazenie VendorID, ProductID a verzie vyrobku
			Text(g_hdcMemWindow, &size, "PID = 0x%.4X", deviceAttributes.ProductID, poloha_x, poloha_y+2*odstup_y, farba, velkost_pisma, 0, "Segoe UI");
			Text(g_hdcMemWindow, &size, "VID = 0x%.4X", deviceAttributes.VendorID, poloha_x+size.cx+10, poloha_y+2*odstup_y, farba, velkost_pisma, 0, "Segoe UI");
			Text(g_hdcMemWindow, &size, "Ver. = 0x%.4X", deviceAttributes.VersionNumber, poloha_x+2*size.cx+20, poloha_y+2*odstup_y, farba, velkost_pisma, 0, "Segoe UI");
					
										
			
			//test
			//_stprintf(TextTMP, "%i", DlzkaSpravyRx);						
			//TextOut(g_hdcMemWindow, 30, 210, TextTMP, lstrlen(TextTMP));				
										
																
			//Stavova ikonka USB pripojenia         
            if(StavPripojeniaUSB == 1)
            	DrawState(g_hdcMemWindow, 0, 0,(LPARAM)g_bmp_z, 0, rect_okna.right-50-1, 1, 0, 0, DST_BITMAP); 
            else
           		DrawState(g_hdcMemWindow, 0, 0,(LPARAM)g_bmp_v, 0, rect_okna.right-50-1, 1, 0, 0, DST_BITMAP); 
 
           		
 			//skopirovanie obsahu bitmapy do okna        
			BitBlt(hdc, 0,0, rect_okna.right, rect_okna.bottom/*-15*/, g_hdcMemWindow,0,0,SRCCOPY);   
			//ObdlznikZaobleny(hdc, 10, 75, 30, 30, 5, 2, RGB(0,0,0), RGB(255,255,0));
			//Obdlznik(hdc, 10, 75, 30, 30, 2, RGB(0,0,0), RGB(255,255,0));
			//Obluk(hdc, 75, 100, 30, 0, 180, 2, RGB(0,0,0)); 		
			//Usecka(hdc, 50, 95, 70, 30, 2, RGB(0,0,0));
			//Elipsa(hdc, 10, 75, 30, 30, 2, RGB(0,0,0), RGB(255,255,0));	
			//VlastnyTvar(hdc, 70, 75, 50, 30, 2, RGB(0,0,0));
			//VlastnyTvarVyplneny(hdc, 70, 75, 50, 30, 2, RGB(0,0,0), RGB(255,255,0));
			EndPaint(hwndDlg, &ps);       
            return TRUE;
        }    		   
    }
    return FALSE;
}    














// HLAVNY PROGRAM
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow) 
{   g_hInstance = hInstance;
	g_nCmdShow = nCmdShow;
	INITCOMMONCONTROLSEX icc;
    icc.dwSize = sizeof(INITCOMMONCONTROLSEX);
    icc.dwICC = ICC_WIN95_CLASSES;
    if ( !InitCommonControlsEx(&icc) )
       return FALSE;      
 	return (int)DialogBox(hInstance, MAKEINTRESOURCE(ID_DIALOG), NULL, (DLGPROC)ProceduraDialogu);	
 	//return (int)CreateDialog(hInstance, MAKEINTRESOURCE(ID_DIALOG), NULL, (DLGPROC)ProceduraDialogu);	
}

